"use strict";
/**
 * Announcements Service API
 * Manage Oracle Cloud Infrastructure console announcements.
 * OpenAPI spec version: 0.0.1
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const model = __importStar(require("../model"));
var BaseAnnouncement;
(function (BaseAnnouncement) {
    let AnnouncementType;
    (function (AnnouncementType) {
        AnnouncementType["ActionRecommended"] = "ACTION_RECOMMENDED";
        AnnouncementType["ActionRequired"] = "ACTION_REQUIRED";
        AnnouncementType["EmergencyChange"] = "EMERGENCY_CHANGE";
        AnnouncementType["EmergencyMaintenance"] = "EMERGENCY_MAINTENANCE";
        AnnouncementType["EmergencyMaintenanceComplete"] = "EMERGENCY_MAINTENANCE_COMPLETE";
        AnnouncementType["EmergencyMaintenanceExtended"] = "EMERGENCY_MAINTENANCE_EXTENDED";
        AnnouncementType["EmergencyMaintenanceRescheduled"] = "EMERGENCY_MAINTENANCE_RESCHEDULED";
        AnnouncementType["Information"] = "INFORMATION";
        AnnouncementType["PlannedChange"] = "PLANNED_CHANGE";
        AnnouncementType["PlannedChangeComplete"] = "PLANNED_CHANGE_COMPLETE";
        AnnouncementType["PlannedChangeExtended"] = "PLANNED_CHANGE_EXTENDED";
        AnnouncementType["PlannedChangeRescheduled"] = "PLANNED_CHANGE_RESCHEDULED";
        AnnouncementType["ProductionEventNotification"] = "PRODUCTION_EVENT_NOTIFICATION";
        AnnouncementType["ScheduledMaintenance"] = "SCHEDULED_MAINTENANCE";
    })(AnnouncementType = BaseAnnouncement.AnnouncementType || (BaseAnnouncement.AnnouncementType = {}));
    let LifecycleState;
    (function (LifecycleState) {
        LifecycleState["Active"] = "ACTIVE";
        LifecycleState["Inactive"] = "INACTIVE";
    })(LifecycleState = BaseAnnouncement.LifecycleState || (BaseAnnouncement.LifecycleState = {}));
    function getJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {});
        if ("type" in obj && obj.type) {
            switch (obj.type) {
                case "AnnouncementSummary":
                    return model.AnnouncementSummary.getJsonObj(jsonObj, true);
                case "Announcement":
                    return model.Announcement.getJsonObj(jsonObj, true);
                default:
                    throw Error("Unknown value for: " + obj.type);
            }
        }
        return jsonObj;
    }
    BaseAnnouncement.getJsonObj = getJsonObj;
})(BaseAnnouncement = exports.BaseAnnouncement || (exports.BaseAnnouncement = {}));
//# sourceMappingURL=base-announcement.js.map