"use strict";
/**
 * Autoscaling API
 * APIs for dynamically scaling Compute resources to meet application requirements. For more information about
autoscaling, see [Autoscaling](/Content/Compute/Tasks/autoscalinginstancepools.htm). For information about the
Compute service, see [Overview of the Compute Service](/Content/Compute/Concepts/computeoverview.htm).

**Note:** Autoscaling is not available in US Government Cloud tenancies. For more information, see
[Oracle Cloud Infrastructure US Government Cloud](/Content/General/Concepts/govoverview.htm).

 * OpenAPI spec version: 20181001
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const model = __importStar(require("../model"));
var CreateAutoScalingPolicyDetails;
(function (CreateAutoScalingPolicyDetails) {
    function getJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {
            "capacity": obj.capacity ? model.Capacity.getJsonObj(obj.capacity) : undefined
        });
        if ("policyType" in obj && obj.policyType) {
            switch (obj.policyType) {
                case "scheduled":
                    return model.CreateScheduledPolicyDetails.getJsonObj(jsonObj, true);
                case "threshold":
                    return model.CreateThresholdPolicyDetails.getJsonObj(jsonObj, true);
                default:
                    throw Error("Unknown value for: " + obj.policyType);
            }
        }
        return jsonObj;
    }
    CreateAutoScalingPolicyDetails.getJsonObj = getJsonObj;
})(CreateAutoScalingPolicyDetails = exports.CreateAutoScalingPolicyDetails || (exports.CreateAutoScalingPolicyDetails = {}));
//# sourceMappingURL=create-auto-scaling-policy-details.js.map