"use strict";
/**
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const auth = __importStar(require("./lib/auth/auth"));
const error = __importStar(require("./lib/error"));
const signer = __importStar(require("./lib/signer"));
const helper = __importStar(require("./lib/helper"));
const http = __importStar(require("./lib/http"));
const serializer = __importStar(require("./lib/object-serializer"));
const range = __importStar(require("./lib/range"));
const region_1 = require("./lib/region");
exports.Region = region_1.Region;
const realm_1 = require("./lib/realm");
exports.Realm = realm_1.Realm;
const endpoint_builder_1 = require("./lib/endpoint-builder");
exports.EndpointBuilder = endpoint_builder_1.EndpointBuilder;
const log_1 = require("./lib/log");
exports.LOG = log_1.LOG;
const constants_1 = __importDefault(require("./lib/constants"));
exports.Constants = constants_1.default;
const circuit_breaker_1 = __importDefault(require("./lib/circuit-breaker"));
exports.CircuitBreaker = circuit_breaker_1.default;
const waiter_1 = require("./lib/waiter");
exports.ExponentialBackoffDelayStrategy = waiter_1.ExponentialBackoffDelayStrategy;
exports.MaxTimeTerminationStrategy = waiter_1.MaxTimeTerminationStrategy;
exports.genericWaiter = waiter_1.genericWaiter;
exports.genericTerminalConditionWaiter = waiter_1.genericTerminalConditionWaiter;
exports.MaxAttemptsTerminationStrategy = waiter_1.MaxAttemptsTerminationStrategy;
exports.FixedTimeDelayStrategy = waiter_1.FixedTimeDelayStrategy;
const retrier_1 = require("./lib/retrier");
exports.GenericRetrier = retrier_1.GenericRetrier;
const instance_principals_authentication_detail_provider_1 = __importDefault(require("./lib/auth/instance-principals-authentication-detail-provider"));
exports.InstancePrincipalsAuthenticationDetailsProviderBuilder = instance_principals_authentication_detail_provider_1.default;
const resource_principal_authentication_details_provider_1 = __importDefault(require("./lib/auth/resource-principal-authentication-details-provider"));
exports.ResourcePrincipalAuthenticationDetailsProvider = resource_principal_authentication_details_provider_1.default;
const paginators_1 = require("./lib/paginators");
exports.paginateRecords = paginators_1.paginateRecords;
exports.genericPaginateRecords = paginators_1.genericPaginateRecords;
exports.paginatedRecordsWithLimit = paginators_1.paginatedRecordsWithLimit;
exports.paginateResponses = paginators_1.paginateResponses;
exports.genericPaginateResponses = paginators_1.genericPaginateResponses;
exports.paginatedResponsesWithLimit = paginators_1.paginatedResponsesWithLimit;
const config_file_auth_1 = require("./lib/auth/config-file-auth");
exports.ConfigFileAuthenticationDetailsProvider = config_file_auth_1.ConfigFileAuthenticationDetailsProvider;
const config_file_reader_1 = require("./lib/config-file-reader");
exports.ConfigFileReader = config_file_reader_1.ConfigFileReader;
const request_generator_1 = require("./lib/request-generator");
exports.composeRequest = request_generator_1.composeRequest;
const response_generator_1 = require("./lib/response-generator");
exports.composeResponse = response_generator_1.composeResponse;
exports.SimpleAuthenticationDetailsProvider = auth.SimpleAuthenticationDetailsProvider;
exports.isRegionProvider = auth.isRegionProvider;
exports.FetchHttpClient = http.FetchHttpClient;
exports.OciError = error.OciError;
exports.DefaultRequestSigner = signer.DefaultRequestSigner;
exports.getStringFromResponseBody = helper.getStringFromResponseBody;
exports.handleErrorResponse = helper.handleErrorResponse;
exports.mapContainer = helper.mapContainer;
exports.handleErrorBody = helper.handleErrorBody;
exports.convertStringToType = helper.convertStringToType;
exports.ObjectSerializer = serializer.ObjectSerializer;
exports.Range = range.Range;
//# sourceMappingURL=index.js.map