/**
 * InstanceAgentService API
 * Instance Agent Service API
 * OpenAPI spec version: 20180530
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Create Command Details
 */
export interface CreateInstanceAgentCommandDetails {
    /**
     * The OCID of the compartment you want to create the command.
     */
    "compartmentId": string;
    /**
     * Command execution time limit. Zero means no timeout.
     */
    "executionTimeOutInSeconds": number;
    /**
     * A user-friendly name for the command. It does not have to be unique.
     * Avoid entering confidential information.
     * Example: `Database Backup Command`
     *
     */
    "displayName"?: string;
    "target": model.InstanceAgentCommandTarget;
    "content": model.InstanceAgentCommandContent;
}
export declare namespace CreateInstanceAgentCommandDetails {
    function getJsonObj(obj: CreateInstanceAgentCommandDetails): object;
}
