"use strict";
/**
 * Core Services API
 * API covering the [Networking](/iaas/Content/Network/Concepts/overview.htm),
[Compute](/iaas/Content/Compute/Concepts/computeoverview.htm), and
[Block Volume](/iaas/Content/Block/Concepts/overview.htm) services. Use this API
to manage resources such as virtual cloud networks (VCNs), compute instances, and
block storage volumes.

 * OpenAPI spec version: 20160918
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const model = __importStar(require("../model"));
var ImageSourceDetails;
(function (ImageSourceDetails) {
    let SourceImageType;
    (function (SourceImageType) {
        SourceImageType["Qcow2"] = "QCOW2";
        SourceImageType["Vmdk"] = "VMDK";
    })(SourceImageType = ImageSourceDetails.SourceImageType || (ImageSourceDetails.SourceImageType = {}));
    function getJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {});
        if ("sourceType" in obj && obj.sourceType) {
            switch (obj.sourceType) {
                case "objectStorageTuple":
                    return model.ImageSourceViaObjectStorageTupleDetails.getJsonObj(jsonObj, true);
                case "objectStorageUri":
                    return model.ImageSourceViaObjectStorageUriDetails.getJsonObj(jsonObj, true);
                default:
                    throw Error("Unknown value for: " + obj.sourceType);
            }
        }
        return jsonObj;
    }
    ImageSourceDetails.getJsonObj = getJsonObj;
})(ImageSourceDetails = exports.ImageSourceDetails || (exports.ImageSourceDetails = {}));
//# sourceMappingURL=image-source-details.js.map