"use strict";
/**
 * Core Services API
 * API covering the [Networking](/iaas/Content/Network/Concepts/overview.htm),
[Compute](/iaas/Content/Compute/Concepts/computeoverview.htm), and
[Block Volume](/iaas/Content/Block/Concepts/overview.htm) services. Use this API
to manage resources such as virtual cloud networks (VCNs), compute instances, and
block storage volumes.

 * OpenAPI spec version: 20160918
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const model = __importStar(require("../model"));
var InstanceConfigurationLaunchInstanceDetails;
(function (InstanceConfigurationLaunchInstanceDetails) {
    let LaunchMode;
    (function (LaunchMode) {
        LaunchMode["Native"] = "NATIVE";
        LaunchMode["Emulated"] = "EMULATED";
        LaunchMode["Paravirtualized"] = "PARAVIRTUALIZED";
        LaunchMode["Custom"] = "CUSTOM";
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        LaunchMode["UnknownValue"] = "UNKNOWN_VALUE";
    })(LaunchMode = InstanceConfigurationLaunchInstanceDetails.LaunchMode || (InstanceConfigurationLaunchInstanceDetails.LaunchMode = {}));
    let PreferredMaintenanceAction;
    (function (PreferredMaintenanceAction) {
        PreferredMaintenanceAction["LiveMigrate"] = "LIVE_MIGRATE";
        PreferredMaintenanceAction["Reboot"] = "REBOOT";
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        PreferredMaintenanceAction["UnknownValue"] = "UNKNOWN_VALUE";
    })(PreferredMaintenanceAction = InstanceConfigurationLaunchInstanceDetails.PreferredMaintenanceAction || (InstanceConfigurationLaunchInstanceDetails.PreferredMaintenanceAction = {}));
    function getJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {
            "createVnicDetails": obj.createVnicDetails
                ? model.InstanceConfigurationCreateVnicDetails.getJsonObj(obj.createVnicDetails)
                : undefined,
            "shapeConfig": obj.shapeConfig
                ? model.InstanceConfigurationLaunchInstanceShapeConfigDetails.getJsonObj(obj.shapeConfig)
                : undefined,
            "sourceDetails": obj.sourceDetails
                ? model.InstanceConfigurationInstanceSourceDetails.getJsonObj(obj.sourceDetails)
                : undefined,
            "launchOptions": obj.launchOptions
                ? model.InstanceConfigurationLaunchOptions.getJsonObj(obj.launchOptions)
                : undefined,
            "agentConfig": obj.agentConfig
                ? model.InstanceConfigurationLaunchInstanceAgentConfigDetails.getJsonObj(obj.agentConfig)
                : undefined,
            "instanceOptions": obj.instanceOptions
                ? model.InstanceConfigurationInstanceOptions.getJsonObj(obj.instanceOptions)
                : undefined,
            "availabilityConfig": obj.availabilityConfig
                ? model.InstanceConfigurationAvailabilityConfig.getJsonObj(obj.availabilityConfig)
                : undefined
        });
        return jsonObj;
    }
    InstanceConfigurationLaunchInstanceDetails.getJsonObj = getJsonObj;
})(InstanceConfigurationLaunchInstanceDetails = exports.InstanceConfigurationLaunchInstanceDetails || (exports.InstanceConfigurationLaunchInstanceDetails = {}));
//# sourceMappingURL=instance-configuration-launch-instance-details.js.map