"use strict";
/**
 * Database Service API
 * The API for the Database Service. Use this API to manage resources such as databases and DB Systems. For more information, see [Overview of the Database Service](/iaas/Content/Database/Concepts/databaseoverview.htm).

 * OpenAPI spec version: 20160918
 * Contact: sic_dbaas_cp_us_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const model = __importStar(require("../model"));
var CreateAutonomousDatabaseBase;
(function (CreateAutonomousDatabaseBase) {
    let DbWorkload;
    (function (DbWorkload) {
        DbWorkload["Oltp"] = "OLTP";
        DbWorkload["Dw"] = "DW";
        DbWorkload["Ajd"] = "AJD";
    })(DbWorkload = CreateAutonomousDatabaseBase.DbWorkload || (CreateAutonomousDatabaseBase.DbWorkload = {}));
    let LicenseModel;
    (function (LicenseModel) {
        LicenseModel["LicenseIncluded"] = "LICENSE_INCLUDED";
        LicenseModel["BringYourOwnLicense"] = "BRING_YOUR_OWN_LICENSE";
    })(LicenseModel = CreateAutonomousDatabaseBase.LicenseModel || (CreateAutonomousDatabaseBase.LicenseModel = {}));
    function getJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {});
        if ("source" in obj && obj.source) {
            switch (obj.source) {
                case "DATABASE":
                    return model.CreateAutonomousDatabaseCloneDetails.getJsonObj(jsonObj, true);
                case "CLONE_TO_REFRESHABLE":
                    return model.CreateRefreshableAutonomousDatabaseCloneDetails.getJsonObj(jsonObj, true);
                case "BACKUP_FROM_ID":
                    return model.CreateAutonomousDatabaseFromBackupDetails.getJsonObj(jsonObj, true);
                case "BACKUP_FROM_TIMESTAMP":
                    return model.CreateAutonomousDatabaseFromBackupTimestampDetails.getJsonObj(jsonObj, true);
                case "NONE":
                    return model.CreateAutonomousDatabaseDetails.getJsonObj(jsonObj, true);
                default:
                    throw Error("Unknown value for: " + obj.source);
            }
        }
        return jsonObj;
    }
    CreateAutonomousDatabaseBase.getJsonObj = getJsonObj;
})(CreateAutonomousDatabaseBase = exports.CreateAutonomousDatabaseBase || (exports.CreateAutonomousDatabaseBase = {}));
//# sourceMappingURL=create-autonomous-database-base.js.map