"use strict";
/**
 * Data Integration API
 * Use the Data Integration Service APIs to perform common extract, load, and transform (ETL) tasks.
 * OpenAPI spec version: 20200430
 * Contact: di_dis_ww_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const model = __importStar(require("../model"));
var CreateConnectionDetails;
(function (CreateConnectionDetails) {
    function getJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {
            "parentRef": obj.parentRef ? model.ParentReference.getJsonObj(obj.parentRef) : undefined,
            "connectionProperties": obj.connectionProperties
                ? obj.connectionProperties.map(item => {
                    return model.ConnectionProperty.getJsonObj(item);
                })
                : undefined,
            "registryMetadata": obj.registryMetadata
                ? model.RegistryMetadata.getJsonObj(obj.registryMetadata)
                : undefined
        });
        if ("modelType" in obj && obj.modelType) {
            switch (obj.modelType) {
                case "MYSQL_CONNECTION":
                    return model.CreateConnectionFromMySQL.getJsonObj(jsonObj, true);
                case "GENERIC_JDBC_CONNECTION":
                    return model.CreateConnectionFromJdbc.getJsonObj(jsonObj, true);
                case "ORACLE_ATP_CONNECTION":
                    return model.CreateConnectionFromAtp.getJsonObj(jsonObj, true);
                case "ORACLE_ADWC_CONNECTION":
                    return model.CreateConnectionFromAdwc.getJsonObj(jsonObj, true);
                case "ORACLEDB_CONNECTION":
                    return model.CreateConnectionFromOracle.getJsonObj(jsonObj, true);
                case "ORACLE_OBJECT_STORAGE_CONNECTION":
                    return model.CreateConnectionFromObjectStorage.getJsonObj(jsonObj, true);
                default:
                    throw Error("Unknown value for: " + obj.modelType);
            }
        }
        return jsonObj;
    }
    CreateConnectionDetails.getJsonObj = getJsonObj;
})(CreateConnectionDetails = exports.CreateConnectionDetails || (exports.CreateConnectionDetails = {}));
//# sourceMappingURL=create-connection-details.js.map