"use strict";
/**
 * Data Integration API
 * Use the Data Integration Service APIs to perform common extract, load, and transform (ETL) tasks.
 * OpenAPI spec version: 20200430
 * Contact: di_dis_ww_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const model = __importStar(require("../model"));
var DataAsset;
(function (DataAsset) {
    function getJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {
            "nativeTypeSystem": obj.nativeTypeSystem
                ? model.TypeSystem.getJsonObj(obj.nativeTypeSystem)
                : undefined,
            "parentRef": obj.parentRef ? model.ParentReference.getJsonObj(obj.parentRef) : undefined,
            "metadata": obj.metadata ? model.ObjectMetadata.getJsonObj(obj.metadata) : undefined
        });
        if ("modelType" in obj && obj.modelType) {
            switch (obj.modelType) {
                case "GENERIC_JDBC_DATA_ASSET":
                    return model.DataAssetFromJdbc.getJsonObj(jsonObj, true);
                case "ORACLE_DATA_ASSET":
                    return model.DataAssetFromOracleDetails.getJsonObj(jsonObj, true);
                case "ORACLE_ADWC_DATA_ASSET":
                    return model.DataAssetFromAdwcDetails.getJsonObj(jsonObj, true);
                case "ORACLE_OBJECT_STORAGE_DATA_ASSET":
                    return model.DataAssetFromObjectStorageDetails.getJsonObj(jsonObj, true);
                case "ORACLE_ATP_DATA_ASSET":
                    return model.DataAssetFromAtpDetails.getJsonObj(jsonObj, true);
                case "MYSQL_DATA_ASSET":
                    return model.DataAssetFromMySQL.getJsonObj(jsonObj, true);
                default:
                    throw Error("Unknown value for: " + obj.modelType);
            }
        }
        return jsonObj;
    }
    DataAsset.getJsonObj = getJsonObj;
})(DataAsset = exports.DataAsset || (exports.DataAsset = {}));
//# sourceMappingURL=data-asset.js.map