"use strict";
/**
 * DNS API
 * API for the DNS service. Use this API to manage DNS zones, records, and other DNS resources.
For more information, see [Overview of the DNS Service](/iaas/Content/DNS/Concepts/dnszonemanagement.htm).

 * OpenAPI spec version: 20180115
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const model = __importStar(require("../model"));
var SteeringPolicy;
(function (SteeringPolicy) {
    let Template;
    (function (Template) {
        Template["Failover"] = "FAILOVER";
        Template["LoadBalance"] = "LOAD_BALANCE";
        Template["RouteByGeo"] = "ROUTE_BY_GEO";
        Template["RouteByAsn"] = "ROUTE_BY_ASN";
        Template["RouteByIp"] = "ROUTE_BY_IP";
        Template["Custom"] = "CUSTOM";
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        Template["UnknownValue"] = "UNKNOWN_VALUE";
    })(Template = SteeringPolicy.Template || (SteeringPolicy.Template = {}));
    let LifecycleState;
    (function (LifecycleState) {
        LifecycleState["Active"] = "ACTIVE";
        LifecycleState["Creating"] = "CREATING";
        LifecycleState["Deleted"] = "DELETED";
        LifecycleState["Deleting"] = "DELETING";
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        LifecycleState["UnknownValue"] = "UNKNOWN_VALUE";
    })(LifecycleState = SteeringPolicy.LifecycleState || (SteeringPolicy.LifecycleState = {}));
    function getJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {
            "answers": obj.answers
                ? obj.answers.map(item => {
                    return model.SteeringPolicyAnswer.getJsonObj(item);
                })
                : undefined,
            "rules": obj.rules
                ? obj.rules.map(item => {
                    return model.SteeringPolicyRule.getJsonObj(item);
                })
                : undefined
        });
        return jsonObj;
    }
    SteeringPolicy.getJsonObj = getJsonObj;
})(SteeringPolicy = exports.SteeringPolicy || (exports.SteeringPolicy = {}));
//# sourceMappingURL=steering-policy.js.map