/**
 * Data Transfer Service API
 * Data Transfer Service API Specification
 * OpenAPI spec version: 1.0.015
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import common = require("oci-common");
import * as requests from "./request";
import * as models from "./model";
import * as responses from "./response";
import { ApplianceExportJobWaiter } from "./applianceexportjob-waiter";
import { TransferApplianceWaiter } from "./transferappliance-waiter";
import { TransferApplianceEntitlementWaiter } from "./transferapplianceentitlement-waiter";
import { TransferDeviceWaiter } from "./transferdevice-waiter";
import { TransferJobWaiter } from "./transferjob-waiter";
import { TransferPackageWaiter } from "./transferpackage-waiter";
export declare enum ApplianceExportJobApiKeys {
}
export declare class ApplianceExportJobClient {
    protected static serviceEndpointTemplate: string;
    protected "_endpoint": string;
    protected "_defaultHeaders": any;
    protected "_waiters": ApplianceExportJobWaiter;
    protected "_clientConfiguration": common.ClientConfiguration;
    protected _circuitBreaker: null;
    protected _httpClient: common.HttpClient;
    constructor(params: common.AuthParams, clientConfiguration?: common.ClientConfiguration);
    /**
     * Get the endpoint that is being used to call (ex, https://www.example.com).
     */
    /**
    * Sets the endpoint to call (ex, https://www.example.com).
    * @param endpoint The endpoint of the service.
    */
    endpoint: string;
    readonly logger: import("oci-common/lib/log").Logger;
    /**
     * Sets the region to call (ex, Region.US_PHOENIX_1).
     * Note, this will call {@link #endpoint(String) endpoint} after resolving the endpoint.
     * @param region The region of the service.
     */
    region: common.Region;
    /**
     * Sets the regionId to call (ex, 'us-phoenix-1').
     *
     * Note, this will first try to map the region ID to a known Region and call {@link #region(Region) region}.
     * If no known Region could be determined, it will create an endpoint assuming its in default Realm OC1
     * and then call {@link #endpoint(String) endpoint}.
     * @param regionId The public region ID.
     */
    regionId: string;
    /**
     * Creates a new ApplianceExportJobWaiter for resources for this service.
     *
     * @param config The waiter configuration for termination and delay strategy
     * @return The service waiters.
     */
    createWaiters(config?: common.WaiterConfiguration): ApplianceExportJobWaiter;
    /**
     * Gets the waiters available for resources for this service.
     *
     * @return The service waiters.
     */
    getWaiters(): ApplianceExportJobWaiter;
    /**
     * Moves a ApplianceExportJob into a different compartment.
     * @param ChangeApplianceExportJobCompartmentRequest
     * @return ChangeApplianceExportJobCompartmentResponse
     * @throws OciError when an error occurs
     */
    changeApplianceExportJobCompartment(changeApplianceExportJobCompartmentRequest: requests.ChangeApplianceExportJobCompartmentRequest): Promise<responses.ChangeApplianceExportJobCompartmentResponse>;
    /**
     * Creates a new Appliance Export Job that corresponds with customer's logical dataset
     * @param CreateApplianceExportJobRequest
     * @return CreateApplianceExportJobResponse
     * @throws OciError when an error occurs
     */
    createApplianceExportJob(createApplianceExportJobRequest: requests.CreateApplianceExportJobRequest): Promise<responses.CreateApplianceExportJobResponse>;
    /**
     * deletes a Appliance Export Job
     * @param DeleteApplianceExportJobRequest
     * @return DeleteApplianceExportJobResponse
     * @throws OciError when an error occurs
     */
    deleteApplianceExportJob(deleteApplianceExportJobRequest: requests.DeleteApplianceExportJobRequest): Promise<responses.DeleteApplianceExportJobResponse>;
    /**
     * Describes a Appliance Export Job in detail
     * @param GetApplianceExportJobRequest
     * @return GetApplianceExportJobResponse
     * @throws OciError when an error occurs
     */
    getApplianceExportJob(getApplianceExportJobRequest: requests.GetApplianceExportJobRequest): Promise<responses.GetApplianceExportJobResponse>;
    /**
     * Lists Appliance Export Jobs in a given compartment
     * @param ListApplianceExportJobsRequest
     * @return ListApplianceExportJobsResponse
     * @throws OciError when an error occurs
     */
    listApplianceExportJobs(listApplianceExportJobsRequest: requests.ListApplianceExportJobsRequest): Promise<responses.ListApplianceExportJobsResponse>;
    /**
     * Creates a new async iterator which will iterate over the models.ApplianceExportJobSummary objects
     * contained in responses from the listApplianceExportJobs operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllApplianceExportJobs(request: requests.ListApplianceExportJobsRequest): AsyncIterableIterator<models.ApplianceExportJobSummary>;
    /**
     * Creates a new async iterator which will iterate over the responses received from the listApplianceExportJobs operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllApplianceExportJobsResponses(request: requests.ListApplianceExportJobsRequest): AsyncIterableIterator<responses.ListApplianceExportJobsResponse>;
    /**
     * Updates a Appliance Export Job that corresponds with customer's logical dataset.
     * @param UpdateApplianceExportJobRequest
     * @return UpdateApplianceExportJobResponse
     * @throws OciError when an error occurs
     */
    updateApplianceExportJob(updateApplianceExportJobRequest: requests.UpdateApplianceExportJobRequest): Promise<responses.UpdateApplianceExportJobResponse>;
}
export declare enum ShippingVendorsApiKeys {
}
export declare class ShippingVendorsClient {
    protected static serviceEndpointTemplate: string;
    protected "_endpoint": string;
    protected "_defaultHeaders": any;
    protected "_clientConfiguration": common.ClientConfiguration;
    protected _circuitBreaker: null;
    protected _httpClient: common.HttpClient;
    constructor(params: common.AuthParams, clientConfiguration?: common.ClientConfiguration);
    /**
     * Get the endpoint that is being used to call (ex, https://www.example.com).
     */
    /**
    * Sets the endpoint to call (ex, https://www.example.com).
    * @param endpoint The endpoint of the service.
    */
    endpoint: string;
    readonly logger: import("oci-common/lib/log").Logger;
    /**
     * Sets the region to call (ex, Region.US_PHOENIX_1).
     * Note, this will call {@link #endpoint(String) endpoint} after resolving the endpoint.
     * @param region The region of the service.
     */
    region: common.Region;
    /**
     * Sets the regionId to call (ex, 'us-phoenix-1').
     *
     * Note, this will first try to map the region ID to a known Region and call {@link #region(Region) region}.
     * If no known Region could be determined, it will create an endpoint assuming its in default Realm OC1
     * and then call {@link #endpoint(String) endpoint}.
     * @param regionId The public region ID.
     */
    regionId: string;
    /**
     * Lists available shipping vendors for Transfer Package delivery
     * @param ListShippingVendorsRequest
     * @return ListShippingVendorsResponse
     * @throws OciError when an error occurs
     */
    listShippingVendors(listShippingVendorsRequest: requests.ListShippingVendorsRequest): Promise<responses.ListShippingVendorsResponse>;
}
export declare enum TransferApplianceApiKeys {
}
export declare class TransferApplianceClient {
    protected static serviceEndpointTemplate: string;
    protected "_endpoint": string;
    protected "_defaultHeaders": any;
    protected "_waiters": TransferApplianceWaiter;
    protected "_clientConfiguration": common.ClientConfiguration;
    protected _circuitBreaker: null;
    protected _httpClient: common.HttpClient;
    constructor(params: common.AuthParams, clientConfiguration?: common.ClientConfiguration);
    /**
     * Get the endpoint that is being used to call (ex, https://www.example.com).
     */
    /**
    * Sets the endpoint to call (ex, https://www.example.com).
    * @param endpoint The endpoint of the service.
    */
    endpoint: string;
    readonly logger: import("oci-common/lib/log").Logger;
    /**
     * Sets the region to call (ex, Region.US_PHOENIX_1).
     * Note, this will call {@link #endpoint(String) endpoint} after resolving the endpoint.
     * @param region The region of the service.
     */
    region: common.Region;
    /**
     * Sets the regionId to call (ex, 'us-phoenix-1').
     *
     * Note, this will first try to map the region ID to a known Region and call {@link #region(Region) region}.
     * If no known Region could be determined, it will create an endpoint assuming its in default Realm OC1
     * and then call {@link #endpoint(String) endpoint}.
     * @param regionId The public region ID.
     */
    regionId: string;
    /**
     * Creates a new TransferApplianceWaiter for resources for this service.
     *
     * @param config The waiter configuration for termination and delay strategy
     * @return The service waiters.
     */
    createWaiters(config?: common.WaiterConfiguration): TransferApplianceWaiter;
    /**
     * Gets the waiters available for resources for this service.
     *
     * @return The service waiters.
     */
    getWaiters(): TransferApplianceWaiter;
    /**
     * Create a new Transfer Appliance
     * @param CreateTransferApplianceRequest
     * @return CreateTransferApplianceResponse
     * @throws OciError when an error occurs
     */
    createTransferAppliance(createTransferApplianceRequest: requests.CreateTransferApplianceRequest): Promise<responses.CreateTransferApplianceResponse>;
    /**
     * Creates an X.509 certificate from a public key
     * @param CreateTransferApplianceAdminCredentialsRequest
     * @return CreateTransferApplianceAdminCredentialsResponse
     * @throws OciError when an error occurs
     */
    createTransferApplianceAdminCredentials(createTransferApplianceAdminCredentialsRequest: requests.CreateTransferApplianceAdminCredentialsRequest): Promise<responses.CreateTransferApplianceAdminCredentialsResponse>;
    /**
     * deletes a transfer Appliance
     * @param DeleteTransferApplianceRequest
     * @return DeleteTransferApplianceResponse
     * @throws OciError when an error occurs
     */
    deleteTransferAppliance(deleteTransferApplianceRequest: requests.DeleteTransferApplianceRequest): Promise<responses.DeleteTransferApplianceResponse>;
    /**
     * Describes a transfer appliance in detail
     * @param GetTransferApplianceRequest
     * @return GetTransferApplianceResponse
     * @throws OciError when an error occurs
     */
    getTransferAppliance(getTransferApplianceRequest: requests.GetTransferApplianceRequest): Promise<responses.GetTransferApplianceResponse>;
    /**
     * Gets the x.509 certificate for the Transfer Appliance's dedicated Certificate Authority (CA)
     * @param GetTransferApplianceCertificateAuthorityCertificateRequest
     * @return GetTransferApplianceCertificateAuthorityCertificateResponse
     * @throws OciError when an error occurs
     */
    getTransferApplianceCertificateAuthorityCertificate(getTransferApplianceCertificateAuthorityCertificateRequest: requests.GetTransferApplianceCertificateAuthorityCertificateRequest): Promise<responses.GetTransferApplianceCertificateAuthorityCertificateResponse>;
    /**
     * Describes a transfer appliance encryptionPassphrase in detail
     * @param GetTransferApplianceEncryptionPassphraseRequest
     * @return GetTransferApplianceEncryptionPassphraseResponse
     * @throws OciError when an error occurs
     */
    getTransferApplianceEncryptionPassphrase(getTransferApplianceEncryptionPassphraseRequest: requests.GetTransferApplianceEncryptionPassphraseRequest): Promise<responses.GetTransferApplianceEncryptionPassphraseResponse>;
    /**
     * Lists Transfer Appliances associated with a transferJob
     * @param ListTransferAppliancesRequest
     * @return ListTransferAppliancesResponse
     * @throws OciError when an error occurs
     */
    listTransferAppliances(listTransferAppliancesRequest: requests.ListTransferAppliancesRequest): Promise<responses.ListTransferAppliancesResponse>;
    /**
     * Updates a Transfer Appliance
     * @param UpdateTransferApplianceRequest
     * @return UpdateTransferApplianceResponse
     * @throws OciError when an error occurs
     */
    updateTransferAppliance(updateTransferApplianceRequest: requests.UpdateTransferApplianceRequest): Promise<responses.UpdateTransferApplianceResponse>;
}
export declare enum TransferApplianceEntitlementApiKeys {
}
export declare class TransferApplianceEntitlementClient {
    protected static serviceEndpointTemplate: string;
    protected "_endpoint": string;
    protected "_defaultHeaders": any;
    protected "_waiters": TransferApplianceEntitlementWaiter;
    protected "_clientConfiguration": common.ClientConfiguration;
    protected _circuitBreaker: null;
    protected _httpClient: common.HttpClient;
    constructor(params: common.AuthParams, clientConfiguration?: common.ClientConfiguration);
    /**
     * Get the endpoint that is being used to call (ex, https://www.example.com).
     */
    /**
    * Sets the endpoint to call (ex, https://www.example.com).
    * @param endpoint The endpoint of the service.
    */
    endpoint: string;
    readonly logger: import("oci-common/lib/log").Logger;
    /**
     * Sets the region to call (ex, Region.US_PHOENIX_1).
     * Note, this will call {@link #endpoint(String) endpoint} after resolving the endpoint.
     * @param region The region of the service.
     */
    region: common.Region;
    /**
     * Sets the regionId to call (ex, 'us-phoenix-1').
     *
     * Note, this will first try to map the region ID to a known Region and call {@link #region(Region) region}.
     * If no known Region could be determined, it will create an endpoint assuming its in default Realm OC1
     * and then call {@link #endpoint(String) endpoint}.
     * @param regionId The public region ID.
     */
    regionId: string;
    /**
     * Creates a new TransferApplianceEntitlementWaiter for resources for this service.
     *
     * @param config The waiter configuration for termination and delay strategy
     * @return The service waiters.
     */
    createWaiters(config?: common.WaiterConfiguration): TransferApplianceEntitlementWaiter;
    /**
     * Gets the waiters available for resources for this service.
     *
     * @return The service waiters.
     */
    getWaiters(): TransferApplianceEntitlementWaiter;
    /**
     * Create the Entitlement to use a Transfer Appliance. It requires some offline process of review and signatures before request is granted.
     * @param CreateTransferApplianceEntitlementRequest
     * @return CreateTransferApplianceEntitlementResponse
     * @throws OciError when an error occurs
     */
    createTransferApplianceEntitlement(createTransferApplianceEntitlementRequest: requests.CreateTransferApplianceEntitlementRequest): Promise<responses.CreateTransferApplianceEntitlementResponse>;
    /**
     * Describes the Transfer Appliance Entitlement in detail
     * @param GetTransferApplianceEntitlementRequest
     * @return GetTransferApplianceEntitlementResponse
     * @throws OciError when an error occurs
     */
    getTransferApplianceEntitlement(getTransferApplianceEntitlementRequest: requests.GetTransferApplianceEntitlementRequest): Promise<responses.GetTransferApplianceEntitlementResponse>;
    /**
     * Lists Transfer Transfer Appliance Entitlement
     * @param ListTransferApplianceEntitlementRequest
     * @return ListTransferApplianceEntitlementResponse
     * @throws OciError when an error occurs
     */
    listTransferApplianceEntitlement(listTransferApplianceEntitlementRequest: requests.ListTransferApplianceEntitlementRequest): Promise<responses.ListTransferApplianceEntitlementResponse>;
}
export declare enum TransferDeviceApiKeys {
}
export declare class TransferDeviceClient {
    protected static serviceEndpointTemplate: string;
    protected "_endpoint": string;
    protected "_defaultHeaders": any;
    protected "_waiters": TransferDeviceWaiter;
    protected "_clientConfiguration": common.ClientConfiguration;
    protected _circuitBreaker: null;
    protected _httpClient: common.HttpClient;
    constructor(params: common.AuthParams, clientConfiguration?: common.ClientConfiguration);
    /**
     * Get the endpoint that is being used to call (ex, https://www.example.com).
     */
    /**
    * Sets the endpoint to call (ex, https://www.example.com).
    * @param endpoint The endpoint of the service.
    */
    endpoint: string;
    readonly logger: import("oci-common/lib/log").Logger;
    /**
     * Sets the region to call (ex, Region.US_PHOENIX_1).
     * Note, this will call {@link #endpoint(String) endpoint} after resolving the endpoint.
     * @param region The region of the service.
     */
    region: common.Region;
    /**
     * Sets the regionId to call (ex, 'us-phoenix-1').
     *
     * Note, this will first try to map the region ID to a known Region and call {@link #region(Region) region}.
     * If no known Region could be determined, it will create an endpoint assuming its in default Realm OC1
     * and then call {@link #endpoint(String) endpoint}.
     * @param regionId The public region ID.
     */
    regionId: string;
    /**
     * Creates a new TransferDeviceWaiter for resources for this service.
     *
     * @param config The waiter configuration for termination and delay strategy
     * @return The service waiters.
     */
    createWaiters(config?: common.WaiterConfiguration): TransferDeviceWaiter;
    /**
     * Gets the waiters available for resources for this service.
     *
     * @return The service waiters.
     */
    getWaiters(): TransferDeviceWaiter;
    /**
     * Create a new Transfer Device
     * @param CreateTransferDeviceRequest
     * @return CreateTransferDeviceResponse
     * @throws OciError when an error occurs
     */
    createTransferDevice(createTransferDeviceRequest: requests.CreateTransferDeviceRequest): Promise<responses.CreateTransferDeviceResponse>;
    /**
     * deletes a transfer Device
     * @param DeleteTransferDeviceRequest
     * @return DeleteTransferDeviceResponse
     * @throws OciError when an error occurs
     */
    deleteTransferDevice(deleteTransferDeviceRequest: requests.DeleteTransferDeviceRequest): Promise<responses.DeleteTransferDeviceResponse>;
    /**
     * Describes a transfer package in detail
     * @param GetTransferDeviceRequest
     * @return GetTransferDeviceResponse
     * @throws OciError when an error occurs
     */
    getTransferDevice(getTransferDeviceRequest: requests.GetTransferDeviceRequest): Promise<responses.GetTransferDeviceResponse>;
    /**
     * Lists Transfer Devices associated with a transferJob
     * @param ListTransferDevicesRequest
     * @return ListTransferDevicesResponse
     * @throws OciError when an error occurs
     */
    listTransferDevices(listTransferDevicesRequest: requests.ListTransferDevicesRequest): Promise<responses.ListTransferDevicesResponse>;
    /**
     * Updates a Transfer Device
     * @param UpdateTransferDeviceRequest
     * @return UpdateTransferDeviceResponse
     * @throws OciError when an error occurs
     */
    updateTransferDevice(updateTransferDeviceRequest: requests.UpdateTransferDeviceRequest): Promise<responses.UpdateTransferDeviceResponse>;
}
export declare enum TransferJobApiKeys {
}
export declare class TransferJobClient {
    protected static serviceEndpointTemplate: string;
    protected "_endpoint": string;
    protected "_defaultHeaders": any;
    protected "_waiters": TransferJobWaiter;
    protected "_clientConfiguration": common.ClientConfiguration;
    protected _circuitBreaker: null;
    protected _httpClient: common.HttpClient;
    constructor(params: common.AuthParams, clientConfiguration?: common.ClientConfiguration);
    /**
     * Get the endpoint that is being used to call (ex, https://www.example.com).
     */
    /**
    * Sets the endpoint to call (ex, https://www.example.com).
    * @param endpoint The endpoint of the service.
    */
    endpoint: string;
    readonly logger: import("oci-common/lib/log").Logger;
    /**
     * Sets the region to call (ex, Region.US_PHOENIX_1).
     * Note, this will call {@link #endpoint(String) endpoint} after resolving the endpoint.
     * @param region The region of the service.
     */
    region: common.Region;
    /**
     * Sets the regionId to call (ex, 'us-phoenix-1').
     *
     * Note, this will first try to map the region ID to a known Region and call {@link #region(Region) region}.
     * If no known Region could be determined, it will create an endpoint assuming its in default Realm OC1
     * and then call {@link #endpoint(String) endpoint}.
     * @param regionId The public region ID.
     */
    regionId: string;
    /**
     * Creates a new TransferJobWaiter for resources for this service.
     *
     * @param config The waiter configuration for termination and delay strategy
     * @return The service waiters.
     */
    createWaiters(config?: common.WaiterConfiguration): TransferJobWaiter;
    /**
     * Gets the waiters available for resources for this service.
     *
     * @return The service waiters.
     */
    getWaiters(): TransferJobWaiter;
    /**
     * Moves a TransferJob into a different compartment.
     * @param ChangeTransferJobCompartmentRequest
     * @return ChangeTransferJobCompartmentResponse
     * @throws OciError when an error occurs
     */
    changeTransferJobCompartment(changeTransferJobCompartmentRequest: requests.ChangeTransferJobCompartmentRequest): Promise<responses.ChangeTransferJobCompartmentResponse>;
    /**
     * Create a new Transfer Job that corresponds with customer's logical dataset e.g. a DB or a filesystem.
     * @param CreateTransferJobRequest
     * @return CreateTransferJobResponse
     * @throws OciError when an error occurs
     */
    createTransferJob(createTransferJobRequest: requests.CreateTransferJobRequest): Promise<responses.CreateTransferJobResponse>;
    /**
     * deletes a transfer job
     * @param DeleteTransferJobRequest
     * @return DeleteTransferJobResponse
     * @throws OciError when an error occurs
     */
    deleteTransferJob(deleteTransferJobRequest: requests.DeleteTransferJobRequest): Promise<responses.DeleteTransferJobResponse>;
    /**
     * Describes a transfer job in detail
     * @param GetTransferJobRequest
     * @return GetTransferJobResponse
     * @throws OciError when an error occurs
     */
    getTransferJob(getTransferJobRequest: requests.GetTransferJobRequest): Promise<responses.GetTransferJobResponse>;
    /**
     * Lists Transfer Jobs in a given compartment
     * @param ListTransferJobsRequest
     * @return ListTransferJobsResponse
     * @throws OciError when an error occurs
     */
    listTransferJobs(listTransferJobsRequest: requests.ListTransferJobsRequest): Promise<responses.ListTransferJobsResponse>;
    /**
     * Creates a new async iterator which will iterate over the models.TransferJobSummary objects
     * contained in responses from the listTransferJobs operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllTransferJobs(request: requests.ListTransferJobsRequest): AsyncIterableIterator<models.TransferJobSummary>;
    /**
     * Creates a new async iterator which will iterate over the responses received from the listTransferJobs operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllTransferJobsResponses(request: requests.ListTransferJobsRequest): AsyncIterableIterator<responses.ListTransferJobsResponse>;
    /**
     * Updates a Transfer Job that corresponds with customer's logical dataset e.g. a DB or a filesystem.
     * @param UpdateTransferJobRequest
     * @return UpdateTransferJobResponse
     * @throws OciError when an error occurs
     */
    updateTransferJob(updateTransferJobRequest: requests.UpdateTransferJobRequest): Promise<responses.UpdateTransferJobResponse>;
}
export declare enum TransferPackageApiKeys {
}
export declare class TransferPackageClient {
    protected static serviceEndpointTemplate: string;
    protected "_endpoint": string;
    protected "_defaultHeaders": any;
    protected "_waiters": TransferPackageWaiter;
    protected "_clientConfiguration": common.ClientConfiguration;
    protected _circuitBreaker: null;
    protected _httpClient: common.HttpClient;
    constructor(params: common.AuthParams, clientConfiguration?: common.ClientConfiguration);
    /**
     * Get the endpoint that is being used to call (ex, https://www.example.com).
     */
    /**
    * Sets the endpoint to call (ex, https://www.example.com).
    * @param endpoint The endpoint of the service.
    */
    endpoint: string;
    readonly logger: import("oci-common/lib/log").Logger;
    /**
     * Sets the region to call (ex, Region.US_PHOENIX_1).
     * Note, this will call {@link #endpoint(String) endpoint} after resolving the endpoint.
     * @param region The region of the service.
     */
    region: common.Region;
    /**
     * Sets the regionId to call (ex, 'us-phoenix-1').
     *
     * Note, this will first try to map the region ID to a known Region and call {@link #region(Region) region}.
     * If no known Region could be determined, it will create an endpoint assuming its in default Realm OC1
     * and then call {@link #endpoint(String) endpoint}.
     * @param regionId The public region ID.
     */
    regionId: string;
    /**
     * Creates a new TransferPackageWaiter for resources for this service.
     *
     * @param config The waiter configuration for termination and delay strategy
     * @return The service waiters.
     */
    createWaiters(config?: common.WaiterConfiguration): TransferPackageWaiter;
    /**
     * Gets the waiters available for resources for this service.
     *
     * @return The service waiters.
     */
    getWaiters(): TransferPackageWaiter;
    /**
     * Attaches Devices to a Transfer Package
     * @param AttachDevicesToTransferPackageRequest
     * @return AttachDevicesToTransferPackageResponse
     * @throws OciError when an error occurs
     */
    attachDevicesToTransferPackage(attachDevicesToTransferPackageRequest: requests.AttachDevicesToTransferPackageRequest): Promise<responses.AttachDevicesToTransferPackageResponse>;
    /**
     * Create a new Transfer Package
     * @param CreateTransferPackageRequest
     * @return CreateTransferPackageResponse
     * @throws OciError when an error occurs
     */
    createTransferPackage(createTransferPackageRequest: requests.CreateTransferPackageRequest): Promise<responses.CreateTransferPackageResponse>;
    /**
     * deletes a transfer Package
     * @param DeleteTransferPackageRequest
     * @return DeleteTransferPackageResponse
     * @throws OciError when an error occurs
     */
    deleteTransferPackage(deleteTransferPackageRequest: requests.DeleteTransferPackageRequest): Promise<responses.DeleteTransferPackageResponse>;
    /**
     * Detaches Devices from a Transfer Package
     * @param DetachDevicesFromTransferPackageRequest
     * @return DetachDevicesFromTransferPackageResponse
     * @throws OciError when an error occurs
     */
    detachDevicesFromTransferPackage(detachDevicesFromTransferPackageRequest: requests.DetachDevicesFromTransferPackageRequest): Promise<responses.DetachDevicesFromTransferPackageResponse>;
    /**
     * Describes a transfer package in detail
     * @param GetTransferPackageRequest
     * @return GetTransferPackageResponse
     * @throws OciError when an error occurs
     */
    getTransferPackage(getTransferPackageRequest: requests.GetTransferPackageRequest): Promise<responses.GetTransferPackageResponse>;
    /**
     * Lists Transfer Packages associated with a transferJob
     * @param ListTransferPackagesRequest
     * @return ListTransferPackagesResponse
     * @throws OciError when an error occurs
     */
    listTransferPackages(listTransferPackagesRequest: requests.ListTransferPackagesRequest): Promise<responses.ListTransferPackagesResponse>;
    /**
     * Updates a Transfer Package
     * @param UpdateTransferPackageRequest
     * @return UpdateTransferPackageResponse
     * @throws OciError when an error occurs
     */
    updateTransferPackage(updateTransferPackageRequest: requests.UpdateTransferPackageRequest): Promise<responses.UpdateTransferPackageResponse>;
}
