/**
 * Oracle Integration API
 * Oracle Integration API.
 * OpenAPI spec version: 20190131
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * The information about new IntegrationInstance.
 */
export interface CreateIntegrationInstanceDetails {
    /**
     * Integration Instance Identifier.
     */
    "displayName": string;
    /**
     * Compartment Identifier.
     */
    "compartmentId": string;
    /**
     * Standard or Enterprise type
     */
    "integrationInstanceType": CreateIntegrationInstanceDetails.IntegrationInstanceType;
    /**
     * Simple key-value pair that is applied without any predefined name,
     * type or scope. Exists for cross-compatibility only.
     * Example: `{\"bar-key\": \"value\"}`
     *
     */
    "freeformTags"?: {
        [key: string]: string;
    };
    /**
     * Usage of predefined tag keys. These predefined keys are scoped to
     * namespaces.
     * Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`
     *
     */
    "definedTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
    /**
     * Bring your own license.
     */
    "isByol": boolean;
    /**
     * IDCS Authentication token. This is is required for pre-UCPIS cloud accounts, but not UCPIS, hence not a required parameter
     */
    "idcsAt"?: string;
    /**
     * The number of configured message packs
     */
    "messagePacks": number;
    /**
     * Optional parameter specifying which entitlement to use for billing purposes. Only required if the account possesses more than one entitlement.
     */
    "consumptionModel"?: CreateIntegrationInstanceDetails.ConsumptionModel;
    /**
     * The file server is enabled or not.
     */
    "isFileServerEnabled"?: boolean;
}
export declare namespace CreateIntegrationInstanceDetails {
    enum IntegrationInstanceType {
        Standard = "STANDARD",
        Enterprise = "ENTERPRISE"
    }
    enum ConsumptionModel {
        Ucm = "UCM",
        Gov = "GOV",
        Oic4Saas = "OIC4SAAS"
    }
    function getJsonObj(obj: CreateIntegrationInstanceDetails): object;
}
