"use strict";
/**
 * Vault Service Key Management API
 * API for managing and performing operations with keys and vaults. (For the API for managing secrets, see the Vault Service
Secret Management API. For the API for retrieving secrets, see the Vault Service Secret Retrieval API.)

 * OpenAPI spec version: release
 * Contact: sparta_kms_us_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const BackupKeyDetails = __importStar(require("./backup-key-details"));
exports.BackupKeyDetails = BackupKeyDetails.BackupKeyDetails;
const BackupLocation = __importStar(require("./backup-location"));
exports.BackupLocation = BackupLocation.BackupLocation;
const BackupVaultDetails = __importStar(require("./backup-vault-details"));
exports.BackupVaultDetails = BackupVaultDetails.BackupVaultDetails;
const ChangeKeyCompartmentDetails = __importStar(require("./change-key-compartment-details"));
exports.ChangeKeyCompartmentDetails = ChangeKeyCompartmentDetails.ChangeKeyCompartmentDetails;
const ChangeVaultCompartmentDetails = __importStar(require("./change-vault-compartment-details"));
exports.ChangeVaultCompartmentDetails = ChangeVaultCompartmentDetails.ChangeVaultCompartmentDetails;
const CreateKeyDetails = __importStar(require("./create-key-details"));
exports.CreateKeyDetails = CreateKeyDetails.CreateKeyDetails;
const CreateVaultDetails = __importStar(require("./create-vault-details"));
exports.CreateVaultDetails = CreateVaultDetails.CreateVaultDetails;
const DecryptDataDetails = __importStar(require("./decrypt-data-details"));
exports.DecryptDataDetails = DecryptDataDetails.DecryptDataDetails;
const DecryptedData = __importStar(require("./decrypted-data"));
exports.DecryptedData = DecryptedData.DecryptedData;
const EncryptDataDetails = __importStar(require("./encrypt-data-details"));
exports.EncryptDataDetails = EncryptDataDetails.EncryptDataDetails;
const EncryptedData = __importStar(require("./encrypted-data"));
exports.EncryptedData = EncryptedData.EncryptedData;
const ExportKeyDetails = __importStar(require("./export-key-details"));
exports.ExportKeyDetails = ExportKeyDetails.ExportKeyDetails;
const ExportedKeyData = __importStar(require("./exported-key-data"));
exports.ExportedKeyData = ExportedKeyData.ExportedKeyData;
const GenerateKeyDetails = __importStar(require("./generate-key-details"));
exports.GenerateKeyDetails = GenerateKeyDetails.GenerateKeyDetails;
const GeneratedKey = __importStar(require("./generated-key"));
exports.GeneratedKey = GeneratedKey.GeneratedKey;
const ImportKeyDetails = __importStar(require("./import-key-details"));
exports.ImportKeyDetails = ImportKeyDetails.ImportKeyDetails;
const ImportKeyVersionDetails = __importStar(require("./import-key-version-details"));
exports.ImportKeyVersionDetails = ImportKeyVersionDetails.ImportKeyVersionDetails;
const Key = __importStar(require("./key"));
exports.Key = Key.Key;
const KeyShape = __importStar(require("./key-shape"));
exports.KeyShape = KeyShape.KeyShape;
const KeySummary = __importStar(require("./key-summary"));
exports.KeySummary = KeySummary.KeySummary;
const KeyVersion = __importStar(require("./key-version"));
exports.KeyVersion = KeyVersion.KeyVersion;
const KeyVersionSummary = __importStar(require("./key-version-summary"));
exports.KeyVersionSummary = KeyVersionSummary.KeyVersionSummary;
const RestoreKeyFromObjectStoreDetails = __importStar(require("./restore-key-from-object-store-details"));
exports.RestoreKeyFromObjectStoreDetails = RestoreKeyFromObjectStoreDetails.RestoreKeyFromObjectStoreDetails;
const RestoreVaultFromObjectStoreDetails = __importStar(require("./restore-vault-from-object-store-details"));
exports.RestoreVaultFromObjectStoreDetails = RestoreVaultFromObjectStoreDetails.RestoreVaultFromObjectStoreDetails;
const ScheduleKeyDeletionDetails = __importStar(require("./schedule-key-deletion-details"));
exports.ScheduleKeyDeletionDetails = ScheduleKeyDeletionDetails.ScheduleKeyDeletionDetails;
const ScheduleKeyVersionDeletionDetails = __importStar(require("./schedule-key-version-deletion-details"));
exports.ScheduleKeyVersionDeletionDetails = ScheduleKeyVersionDeletionDetails.ScheduleKeyVersionDeletionDetails;
const ScheduleVaultDeletionDetails = __importStar(require("./schedule-vault-deletion-details"));
exports.ScheduleVaultDeletionDetails = ScheduleVaultDeletionDetails.ScheduleVaultDeletionDetails;
const UpdateKeyDetails = __importStar(require("./update-key-details"));
exports.UpdateKeyDetails = UpdateKeyDetails.UpdateKeyDetails;
const UpdateVaultDetails = __importStar(require("./update-vault-details"));
exports.UpdateVaultDetails = UpdateVaultDetails.UpdateVaultDetails;
const Vault = __importStar(require("./vault"));
exports.Vault = Vault.Vault;
const VaultSummary = __importStar(require("./vault-summary"));
exports.VaultSummary = VaultSummary.VaultSummary;
const VaultUsage = __importStar(require("./vault-usage"));
exports.VaultUsage = VaultUsage.VaultUsage;
const WrappedImportKey = __importStar(require("./wrapped-import-key"));
exports.WrappedImportKey = WrappedImportKey.WrappedImportKey;
const WrappingKey = __importStar(require("./wrapping-key"));
exports.WrappingKey = WrappingKey.WrappingKey;
const BackupLocationBucket = __importStar(require("./backup-location-bucket"));
exports.BackupLocationBucket = BackupLocationBucket.BackupLocationBucket;
const BackupLocationURI = __importStar(require("./backup-location-ur-i"));
exports.BackupLocationURI = BackupLocationURI.BackupLocationURI;
//# sourceMappingURL=index.js.map