/**
 * LogAnalytics API
 * The LogAnalytics API for the LogAnalytics service.

 * OpenAPI spec version: 20200601
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import common = require("oci-common");
import * as requests from "./request";
import * as responses from "./response";
import { LogAnalyticsWaiter } from "./loganalytics-waiter";
export declare enum LogAnalyticsApiKeys {
}
export declare class LogAnalyticsClient {
    protected static serviceEndpointTemplate: string;
    protected "_endpoint": string;
    protected "_defaultHeaders": any;
    protected "_waiters": LogAnalyticsWaiter;
    protected "_clientConfiguration": common.ClientConfiguration;
    protected _circuitBreaker: null;
    protected _httpClient: common.HttpClient;
    constructor(params: common.AuthParams, clientConfiguration?: common.ClientConfiguration);
    /**
     * Get the endpoint that is being used to call (ex, https://www.example.com).
     */
    /**
    * Sets the endpoint to call (ex, https://www.example.com).
    * @param endpoint The endpoint of the service.
    */
    endpoint: string;
    readonly logger: import("oci-common/lib/log").Logger;
    /**
     * Sets the region to call (ex, Region.US_PHOENIX_1).
     * Note, this will call {@link #endpoint(String) endpoint} after resolving the endpoint.
     * @param region The region of the service.
     */
    region: common.Region;
    /**
     * Sets the regionId to call (ex, 'us-phoenix-1').
     *
     * Note, this will first try to map the region ID to a known Region and call {@link #region(Region) region}.
     * If no known Region could be determined, it will create an endpoint assuming its in default Realm OC1
     * and then call {@link #endpoint(String) endpoint}.
     * @param regionId The public region ID.
     */
    regionId: string;
    /**
     * Creates a new LogAnalyticsWaiter for resources for this service.
     *
     * @param config The waiter configuration for termination and delay strategy
     * @return The service waiters.
     */
    createWaiters(config?: common.WaiterConfiguration): LogAnalyticsWaiter;
    /**
     * Gets the waiters available for resources for this service.
     *
     * @return The service waiters.
     */
    getWaiters(): LogAnalyticsWaiter;
    /**
     * Adds association between input source log analytics entity and destination entities.
     * @param AddEntityAssociationRequest
     * @return AddEntityAssociationResponse
     * @throws OciError when an error occurs
     */
    addEntityAssociation(addEntityAssociationRequest: requests.AddEntityAssociationRequest): Promise<responses.AddEntityAssociationResponse>;
    /**
     * get basic information about a specified set of labels
     * @param BatchGetBasicInfoRequest
     * @return BatchGetBasicInfoResponse
     * @throws OciError when an error occurs
     */
    batchGetBasicInfo(batchGetBasicInfoRequest: requests.BatchGetBasicInfoRequest): Promise<responses.BatchGetBasicInfoResponse>;
    /**
     * Cancel/Remove query job work request.
     * @param CancelQueryWorkRequestRequest
     * @return CancelQueryWorkRequestResponse
     * @throws OciError when an error occurs
     */
    cancelQueryWorkRequest(cancelQueryWorkRequestRequest: requests.CancelQueryWorkRequestRequest): Promise<responses.CancelQueryWorkRequestResponse>;
    /**
     * Update the compartment of the log analytics entity with the given id.
     * @param ChangeLogAnalyticsEntityCompartmentRequest
     * @return ChangeLogAnalyticsEntityCompartmentResponse
     * @throws OciError when an error occurs
     */
    changeLogAnalyticsEntityCompartment(changeLogAnalyticsEntityCompartmentRequest: requests.ChangeLogAnalyticsEntityCompartmentRequest): Promise<responses.ChangeLogAnalyticsEntityCompartmentResponse>;
    /**
     * Updates the compartment of the Log-Analytics group with the given id.
     * @param ChangeLogAnalyticsLogGroupCompartmentRequest
     * @return ChangeLogAnalyticsLogGroupCompartmentResponse
     * @throws OciError when an error occurs
     */
    changeLogAnalyticsLogGroupCompartment(changeLogAnalyticsLogGroupCompartmentRequest: requests.ChangeLogAnalyticsLogGroupCompartmentRequest): Promise<responses.ChangeLogAnalyticsLogGroupCompartmentResponse>;
    /**
     * Move the rule from it's current compartment to given compartment.
     * @param ChangeLogAnalyticsObjectCollectionRuleCompartmentRequest
     * @return ChangeLogAnalyticsObjectCollectionRuleCompartmentResponse
     * @throws OciError when an error occurs
     */
    changeLogAnalyticsObjectCollectionRuleCompartment(changeLogAnalyticsObjectCollectionRuleCompartmentRequest: requests.ChangeLogAnalyticsObjectCollectionRuleCompartmentRequest): Promise<responses.ChangeLogAnalyticsObjectCollectionRuleCompartmentResponse>;
    /**
     * Move the scheduled task into a different compartment within the same tenancy.
     *
     * @param ChangeScheduledTaskCompartmentRequest
     * @return ChangeScheduledTaskCompartmentResponse
     * @throws OciError when an error occurs
     */
    changeScheduledTaskCompartment(changeScheduledTaskCompartmentRequest: requests.ChangeScheduledTaskCompartmentRequest): Promise<responses.ChangeScheduledTaskCompartmentResponse>;
    /**
     * Clean accumulated acceleration data stored for the accelerated saved search.
     * The ScheduledTask taskType must be ACCELERATION.
     *
     * @param CleanRequest
     * @return CleanResponse
     * @throws OciError when an error occurs
     */
    clean(cleanRequest: requests.CleanRequest): Promise<responses.CleanResponse>;
    /**
     * Create a new log analytics entity.
     * @param CreateLogAnalyticsEntityRequest
     * @return CreateLogAnalyticsEntityResponse
     * @throws OciError when an error occurs
     */
    createLogAnalyticsEntity(createLogAnalyticsEntityRequest: requests.CreateLogAnalyticsEntityRequest): Promise<responses.CreateLogAnalyticsEntityResponse>;
    /**
     * Add custom log analytics entity type.
     * @param CreateLogAnalyticsEntityTypeRequest
     * @return CreateLogAnalyticsEntityTypeResponse
     * @throws OciError when an error occurs
     */
    createLogAnalyticsEntityType(createLogAnalyticsEntityTypeRequest: requests.CreateLogAnalyticsEntityTypeRequest): Promise<responses.CreateLogAnalyticsEntityTypeResponse>;
    /**
     * Creates a new Log-Analytics group.
     * @param CreateLogAnalyticsLogGroupRequest
     * @return CreateLogAnalyticsLogGroupResponse
     * @throws OciError when an error occurs
     */
    createLogAnalyticsLogGroup(createLogAnalyticsLogGroupRequest: requests.CreateLogAnalyticsLogGroupRequest): Promise<responses.CreateLogAnalyticsLogGroupResponse>;
    /**
     * Create a configuration to collect logs from object storage bucket.
     * @param CreateLogAnalyticsObjectCollectionRuleRequest
     * @return CreateLogAnalyticsObjectCollectionRuleResponse
     * @throws OciError when an error occurs
     */
    createLogAnalyticsObjectCollectionRule(createLogAnalyticsObjectCollectionRuleRequest: requests.CreateLogAnalyticsObjectCollectionRuleRequest): Promise<responses.CreateLogAnalyticsObjectCollectionRuleResponse>;
    /**
     * Schedule a task as specified and return task info.
     * @param CreateScheduledTaskRequest
     * @return CreateScheduledTaskResponse
     * @throws OciError when an error occurs
     */
    createScheduledTask(createScheduledTaskRequest: requests.CreateScheduledTaskRequest): Promise<responses.CreateScheduledTaskResponse>;
    /**
     * delete associations
     * @param DeleteAssociationsRequest
     * @return DeleteAssociationsResponse
     * @throws OciError when an error occurs
     */
    deleteAssociations(deleteAssociationsRequest: requests.DeleteAssociationsRequest): Promise<responses.DeleteAssociationsResponse>;
    /**
     * delete field with specified name
     * @param DeleteFieldRequest
     * @return DeleteFieldResponse
     * @throws OciError when an error occurs
     */
    deleteField(deleteFieldRequest: requests.DeleteFieldRequest): Promise<responses.DeleteFieldResponse>;
    /**
     * delete a label
     * @param DeleteLabelRequest
     * @return DeleteLabelResponse
     * @throws OciError when an error occurs
     */
    deleteLabel(deleteLabelRequest: requests.DeleteLabelRequest): Promise<responses.DeleteLabelResponse>;
    /**
     * Delete log analytics entity with the given id.
     * @param DeleteLogAnalyticsEntityRequest
     * @return DeleteLogAnalyticsEntityResponse
     * @throws OciError when an error occurs
     */
    deleteLogAnalyticsEntity(deleteLogAnalyticsEntityRequest: requests.DeleteLogAnalyticsEntityRequest): Promise<responses.DeleteLogAnalyticsEntityResponse>;
    /**
     * Delete the log analytics entity type with the given name.
     * @param DeleteLogAnalyticsEntityTypeRequest
     * @return DeleteLogAnalyticsEntityTypeResponse
     * @throws OciError when an error occurs
     */
    deleteLogAnalyticsEntityType(deleteLogAnalyticsEntityTypeRequest: requests.DeleteLogAnalyticsEntityTypeRequest): Promise<responses.DeleteLogAnalyticsEntityTypeResponse>;
    /**
     * Deletes the Log-Analytics group with the given id.
     * @param DeleteLogAnalyticsLogGroupRequest
     * @return DeleteLogAnalyticsLogGroupResponse
     * @throws OciError when an error occurs
     */
    deleteLogAnalyticsLogGroup(deleteLogAnalyticsLogGroupRequest: requests.DeleteLogAnalyticsLogGroupRequest): Promise<responses.DeleteLogAnalyticsLogGroupResponse>;
    /**
     * Deletes a configured object storage bucket based collection rule to stop the log collection of the configured bucket .
     * It will not delete the already collected log data from the configured bucket.
     *
     * @param DeleteLogAnalyticsObjectCollectionRuleRequest
     * @return DeleteLogAnalyticsObjectCollectionRuleResponse
     * @throws OciError when an error occurs
     */
    deleteLogAnalyticsObjectCollectionRule(deleteLogAnalyticsObjectCollectionRuleRequest: requests.DeleteLogAnalyticsObjectCollectionRuleRequest): Promise<responses.DeleteLogAnalyticsObjectCollectionRuleResponse>;
    /**
     * delete parser with specified name
     * @param DeleteParserRequest
     * @return DeleteParserResponse
     * @throws OciError when an error occurs
     */
    deleteParser(deleteParserRequest: requests.DeleteParserRequest): Promise<responses.DeleteParserResponse>;
    /**
     * Delete the scheduled task.
     * @param DeleteScheduledTaskRequest
     * @return DeleteScheduledTaskResponse
     * @throws OciError when an error occurs
     */
    deleteScheduledTask(deleteScheduledTaskRequest: requests.DeleteScheduledTaskRequest): Promise<responses.DeleteScheduledTaskResponse>;
    /**
     * delete source with specified ID
     * @param DeleteSourceRequest
     * @return DeleteSourceResponse
     * @throws OciError when an error occurs
     */
    deleteSource(deleteSourceRequest: requests.DeleteSourceRequest): Promise<responses.DeleteSourceResponse>;
    /**
     * Deletes an Upload by its reference.
     * It deletes all the logs in storage asscoiated with the upload and the corresponding upload metadata.
     *
     * @param DeleteUploadRequest
     * @return DeleteUploadResponse
     * @throws OciError when an error occurs
     */
    deleteUpload(deleteUploadRequest: requests.DeleteUploadRequest): Promise<responses.DeleteUploadResponse>;
    /**
     * Deletes a specific log file inside an upload by providing upload file reference.
     * It deletes all the logs in storage asscoiated with the upload file and the corresponding upload metadata.
     *
     * @param DeleteUploadFileRequest
     * @return DeleteUploadFileResponse
     * @throws OciError when an error occurs
     */
    deleteUploadFile(deleteUploadFileRequest: requests.DeleteUploadFileRequest): Promise<responses.DeleteUploadFileResponse>;
    /**
     * Suppresses a specific warning inside an upload.
     *
     * @param DeleteUploadWarningRequest
     * @return DeleteUploadWarningResponse
     * @throws OciError when an error occurs
     */
    deleteUploadWarning(deleteUploadWarningRequest: requests.DeleteUploadWarningRequest): Promise<responses.DeleteUploadWarningResponse>;
    /**
     * This API disables archiving.
     *
     * @param DisableArchivingRequest
     * @return DisableArchivingResponse
     * @throws OciError when an error occurs
     */
    disableArchiving(disableArchivingRequest: requests.DisableArchivingRequest): Promise<responses.DisableArchivingResponse>;
    /**
     * THis API enables archiving.
     *
     * @param EnableArchivingRequest
     * @return EnableArchivingResponse
     * @throws OciError when an error occurs
     */
    enableArchiving(enableArchivingRequest: requests.EnableArchivingRequest): Promise<responses.EnableArchivingResponse>;
    /**
     * This API estimates the size of data to be purged based based on time interval, purge query etc.
     *
     * @param EstimatePurgeDataSizeRequest
     * @return EstimatePurgeDataSizeResponse
     * @throws OciError when an error occurs
     */
    estimatePurgeDataSize(estimatePurgeDataSizeRequest: requests.EstimatePurgeDataSizeRequest): Promise<responses.EstimatePurgeDataSizeResponse>;
    /**
     * export
     * @param ExportCustomContentRequest
     * @return ExportCustomContentResponse
     * @throws OciError when an error occurs
     */
    exportCustomContent(exportCustomContentRequest: requests.ExportCustomContentRequest): Promise<responses.ExportCustomContentResponse>;
    /**
     * Export data based on query. Endpoint returns a stream of data. Endpoint is synchronous. Queries must deliver first result within 60 seconds or calls are subject to timeout.
     * @param ExportQueryResultRequest
     * @return ExportQueryResultResponse
     * @throws OciError when an error occurs
     */
    exportQueryResult(exportQueryResultRequest: requests.ExportQueryResultRequest): Promise<responses.ExportQueryResultResponse>;
    /**
     * structured log fieldpaths
     * @param ExtractStructuredLogFieldPathsRequest
     * @return ExtractStructuredLogFieldPathsResponse
     * @throws OciError when an error occurs
     */
    extractStructuredLogFieldPaths(extractStructuredLogFieldPathsRequest: requests.ExtractStructuredLogFieldPathsRequest): Promise<responses.ExtractStructuredLogFieldPathsResponse>;
    /**
     * structured log header paths
     * @param ExtractStructuredLogHeaderPathsRequest
     * @return ExtractStructuredLogHeaderPathsResponse
     * @throws OciError when an error occurs
     */
    extractStructuredLogHeaderPaths(extractStructuredLogHeaderPathsRequest: requests.ExtractStructuredLogHeaderPathsRequest): Promise<responses.ExtractStructuredLogHeaderPathsResponse>;
    /**
     * Each filter specifies an operator, a field and one or more values to be inserted into the provided query as criteria.
     * @param FilterRequest
     * @return FilterResponse
     * @throws OciError when an error occurs
     */
    filter(filterRequest: requests.FilterRequest): Promise<responses.FilterResponse>;
    /**
     * association summary
     * @param GetAssociationSummaryRequest
     * @return GetAssociationSummaryResponse
     * @throws OciError when an error occurs
     */
    getAssociationSummary(getAssociationSummaryRequest: requests.GetAssociationSummaryRequest): Promise<responses.GetAssociationSummaryResponse>;
    /**
     * extract column names from SQL query
     * @param GetColumnNamesRequest
     * @return GetColumnNamesResponse
     * @throws OciError when an error occurs
     */
    getColumnNames(getColumnNamesRequest: requests.GetColumnNamesRequest): Promise<responses.GetColumnNamesResponse>;
    /**
     * association summary by source
     * @param GetConfigWorkRequestRequest
     * @return GetConfigWorkRequestResponse
     * @throws OciError when an error occurs
     */
    getConfigWorkRequest(getConfigWorkRequestRequest: requests.GetConfigWorkRequestRequest): Promise<responses.GetConfigWorkRequestResponse>;
    /**
     * get common field with specified name
     * @param GetFieldRequest
     * @return GetFieldResponse
     * @throws OciError when an error occurs
     */
    getField(getFieldRequest: requests.GetFieldRequest): Promise<responses.GetFieldResponse>;
    /**
     * get field summary
     * @param GetFieldsSummaryRequest
     * @return GetFieldsSummaryResponse
     * @throws OciError when an error occurs
     */
    getFieldsSummary(getFieldsSummaryRequest: requests.GetFieldsSummaryRequest): Promise<responses.GetFieldsSummaryResponse>;
    /**
     * get label with specified name
     * @param GetLabelRequest
     * @return GetLabelResponse
     * @throws OciError when an error occurs
     */
    getLabel(getLabelRequest: requests.GetLabelRequest): Promise<responses.GetLabelResponse>;
    /**
     * get total count
     * @param GetLabelSummaryRequest
     * @return GetLabelSummaryResponse
     * @throws OciError when an error occurs
     */
    getLabelSummary(getLabelSummaryRequest: requests.GetLabelSummaryRequest): Promise<responses.GetLabelSummaryResponse>;
    /**
     * Returns log analytics entities count summary.
     * @param GetLogAnalyticsEntitiesSummaryRequest
     * @return GetLogAnalyticsEntitiesSummaryResponse
     * @throws OciError when an error occurs
     */
    getLogAnalyticsEntitiesSummary(getLogAnalyticsEntitiesSummaryRequest: requests.GetLogAnalyticsEntitiesSummaryRequest): Promise<responses.GetLogAnalyticsEntitiesSummaryResponse>;
    /**
     * Retrieve the log analytics entity with the given id.
     * @param GetLogAnalyticsEntityRequest
     * @return GetLogAnalyticsEntityResponse
     * @throws OciError when an error occurs
     */
    getLogAnalyticsEntity(getLogAnalyticsEntityRequest: requests.GetLogAnalyticsEntityRequest): Promise<responses.GetLogAnalyticsEntityResponse>;
    /**
     * Retrieve the log analytics entity type with the given name.
     * @param GetLogAnalyticsEntityTypeRequest
     * @return GetLogAnalyticsEntityTypeResponse
     * @throws OciError when an error occurs
     */
    getLogAnalyticsEntityType(getLogAnalyticsEntityTypeRequest: requests.GetLogAnalyticsEntityTypeRequest): Promise<responses.GetLogAnalyticsEntityTypeResponse>;
    /**
     * Retrieves the Log-Analytics group with the given id.
     * @param GetLogAnalyticsLogGroupRequest
     * @return GetLogAnalyticsLogGroupResponse
     * @throws OciError when an error occurs
     */
    getLogAnalyticsLogGroup(getLogAnalyticsLogGroupRequest: requests.GetLogAnalyticsLogGroupRequest): Promise<responses.GetLogAnalyticsLogGroupResponse>;
    /**
     * Returns a count of Log-Analytics groups.
     * @param GetLogAnalyticsLogGroupsSummaryRequest
     * @return GetLogAnalyticsLogGroupsSummaryResponse
     * @throws OciError when an error occurs
     */
    getLogAnalyticsLogGroupsSummary(getLogAnalyticsLogGroupsSummaryRequest: requests.GetLogAnalyticsLogGroupsSummaryRequest): Promise<responses.GetLogAnalyticsLogGroupsSummaryResponse>;
    /**
     * Gets a configured object storage based collection rule by given id
     * @param GetLogAnalyticsObjectCollectionRuleRequest
     * @return GetLogAnalyticsObjectCollectionRuleResponse
     * @throws OciError when an error occurs
     */
    getLogAnalyticsObjectCollectionRule(getLogAnalyticsObjectCollectionRuleRequest: requests.GetLogAnalyticsObjectCollectionRuleRequest): Promise<responses.GetLogAnalyticsObjectCollectionRuleResponse>;
    /**
     * This API gets the namespace details of a tenancy already onboarded in Logging Analytics Application
     *
     * @param GetNamespaceRequest
     * @return GetNamespaceResponse
     * @throws OciError when an error occurs
     */
    getNamespace(getNamespaceRequest: requests.GetNamespaceRequest): Promise<responses.GetNamespaceResponse>;
    /**
     * get parser with fields by Name
     * @param GetParserRequest
     * @return GetParserResponse
     * @throws OciError when an error occurs
     */
    getParser(getParserRequest: requests.GetParserRequest): Promise<responses.GetParserResponse>;
    /**
     * parser summary
     * @param GetParserSummaryRequest
     * @return GetParserSummaryResponse
     * @throws OciError when an error occurs
     */
    getParserSummary(getParserSummaryRequest: requests.GetParserSummaryRequest): Promise<responses.GetParserSummaryResponse>;
    /**
     * Returns the intermediate results for a query that was specified to run asynchronously if the query has not completed,
     * otherwise the final query results identified by a queryWorkRequestId returned when submitting the query execute asynchronously.
     *
     * @param GetQueryResultRequest
     * @return GetQueryResultResponse
     * @throws OciError when an error occurs
     */
    getQueryResult(getQueryResultRequest: requests.GetQueryResultRequest): Promise<responses.GetQueryResultResponse>;
    /**
     * Retrieve work request details by workRequestId. This endpoint can be polled for status tracking of work request. Clients should poll using the interval returned in the retry-after header.
     * @param GetQueryWorkRequestRequest
     * @return GetQueryWorkRequestResponse
     * @throws OciError when an error occurs
     */
    getQueryWorkRequest(getQueryWorkRequestRequest: requests.GetQueryWorkRequestRequest): Promise<responses.GetQueryWorkRequestResponse>;
    /**
     * Get the scheduled task for the specified task identifier.
     * @param GetScheduledTaskRequest
     * @return GetScheduledTaskResponse
     * @throws OciError when an error occurs
     */
    getScheduledTask(getScheduledTaskRequest: requests.GetScheduledTaskRequest): Promise<responses.GetScheduledTaskResponse>;
    /**
     * get source with specified name
     * @param GetSourceRequest
     * @return GetSourceResponse
     * @throws OciError when an error occurs
     */
    getSource(getSourceRequest: requests.GetSourceRequest): Promise<responses.GetSourceResponse>;
    /**
     * source summary
     * @param GetSourceSummaryRequest
     * @return GetSourceSummaryResponse
     * @throws OciError when an error occurs
     */
    getSourceSummary(getSourceSummaryRequest: requests.GetSourceSummaryRequest): Promise<responses.GetSourceSummaryResponse>;
    /**
     * This API gets the storage configuration of a tenancy
     *
     * @param GetStorageRequest
     * @return GetStorageResponse
     * @throws OciError when an error occurs
     */
    getStorage(getStorageRequest: requests.GetStorageRequest): Promise<responses.GetStorageResponse>;
    /**
     * This API gets storage usage information of a tenancy.  Storage usage information includes active, archived or recalled
     * data.  The unit of return data is in bytes.
     *
     * @param GetStorageUsageRequest
     * @return GetStorageUsageResponse
     * @throws OciError when an error occurs
     */
    getStorageUsage(getStorageUsageRequest: requests.GetStorageUsageRequest): Promise<responses.GetStorageUsageResponse>;
    /**
     * This API returns work request details specified by {workRequestId}. This API can be polled for status tracking of
     * work request.  Clients should poll using the interval returned in retry-after header.
     *
     * @param GetStorageWorkRequestRequest
     * @return GetStorageWorkRequestResponse
     * @throws OciError when an error occurs
     */
    getStorageWorkRequest(getStorageWorkRequestRequest: requests.GetStorageWorkRequestRequest): Promise<responses.GetStorageWorkRequestResponse>;
    /**
     * Gets an On-Demand Upload info by reference
     * @param GetUploadRequest
     * @return GetUploadResponse
     * @throws OciError when an error occurs
     */
    getUpload(getUploadRequest: requests.GetUploadRequest): Promise<responses.GetUploadResponse>;
    /**
     * Gets the status of the work request with the given ID.
     * @param GetWorkRequestRequest
     * @return GetWorkRequestResponse
     * @throws OciError when an error occurs
     */
    getWorkRequest(getWorkRequestRequest: requests.GetWorkRequestRequest): Promise<responses.GetWorkRequestResponse>;
    /**
     * register custom content
     * @param ImportCustomContentRequest
     * @return ImportCustomContentResponse
     * @throws OciError when an error occurs
     */
    importCustomContent(importCustomContentRequest: requests.ImportCustomContentRequest): Promise<responses.ImportCustomContentResponse>;
    /**
     * list of entities that have been associated to at least one source
     * @param ListAssociatedEntitiesRequest
     * @return ListAssociatedEntitiesResponse
     * @throws OciError when an error occurs
     */
    listAssociatedEntities(listAssociatedEntitiesRequest: requests.ListAssociatedEntitiesRequest): Promise<responses.ListAssociatedEntitiesResponse>;
    /**
     * association summary by source
     * @param ListConfigWorkRequestsRequest
     * @return ListConfigWorkRequestsResponse
     * @throws OciError when an error occurs
     */
    listConfigWorkRequests(listConfigWorkRequestsRequest: requests.ListConfigWorkRequestsRequest): Promise<responses.ListConfigWorkRequestsResponse>;
    /**
     * Return a list of log analytics entities associated with input source log analytics entity.
     * @param ListEntityAssociationsRequest
     * @return ListEntityAssociationsResponse
     * @throws OciError when an error occurs
     */
    listEntityAssociations(listEntityAssociationsRequest: requests.ListEntityAssociationsRequest): Promise<responses.ListEntityAssociationsResponse>;
    /**
     * entity associations summary
     * @param ListEntitySourceAssociationsRequest
     * @return ListEntitySourceAssociationsResponse
     * @throws OciError when an error occurs
     */
    listEntitySourceAssociations(listEntitySourceAssociationsRequest: requests.ListEntitySourceAssociationsRequest): Promise<responses.ListEntitySourceAssociationsResponse>;
    /**
     * get all common field with specified display name and description
     * @param ListFieldsRequest
     * @return ListFieldsResponse
     * @throws OciError when an error occurs
     */
    listFields(listFieldsRequest: requests.ListFieldsRequest): Promise<responses.ListFieldsResponse>;
    /**
     * get list of priorities
     * @param ListLabelPrioritiesRequest
     * @return ListLabelPrioritiesResponse
     * @throws OciError when an error occurs
     */
    listLabelPriorities(listLabelPrioritiesRequest: requests.ListLabelPrioritiesRequest): Promise<responses.ListLabelPrioritiesResponse>;
    /**
     * get details of sources using the label
     * @param ListLabelSourceDetailsRequest
     * @return ListLabelSourceDetailsResponse
     * @throws OciError when an error occurs
     */
    listLabelSourceDetails(listLabelSourceDetailsRequest: requests.ListLabelSourceDetailsRequest): Promise<responses.ListLabelSourceDetailsResponse>;
    /**
     * get labels passing specified filter
     * @param ListLabelsRequest
     * @return ListLabelsResponse
     * @throws OciError when an error occurs
     */
    listLabels(listLabelsRequest: requests.ListLabelsRequest): Promise<responses.ListLabelsResponse>;
    /**
     * Return a list of log analytics entities.
     * @param ListLogAnalyticsEntitiesRequest
     * @return ListLogAnalyticsEntitiesResponse
     * @throws OciError when an error occurs
     */
    listLogAnalyticsEntities(listLogAnalyticsEntitiesRequest: requests.ListLogAnalyticsEntitiesRequest): Promise<responses.ListLogAnalyticsEntitiesResponse>;
    /**
     * Return a list of log analytics entity types.
     * @param ListLogAnalyticsEntityTypesRequest
     * @return ListLogAnalyticsEntityTypesResponse
     * @throws OciError when an error occurs
     */
    listLogAnalyticsEntityTypes(listLogAnalyticsEntityTypesRequest: requests.ListLogAnalyticsEntityTypesRequest): Promise<responses.ListLogAnalyticsEntityTypesResponse>;
    /**
     * Returns a list of Log-Analytics groups.
     * @param ListLogAnalyticsLogGroupsRequest
     * @return ListLogAnalyticsLogGroupsResponse
     * @throws OciError when an error occurs
     */
    listLogAnalyticsLogGroups(listLogAnalyticsLogGroupsRequest: requests.ListLogAnalyticsLogGroupsRequest): Promise<responses.ListLogAnalyticsLogGroupsResponse>;
    /**
     * Gets list of configuration details of Object Storage based collection rules.
     * @param ListLogAnalyticsObjectCollectionRulesRequest
     * @return ListLogAnalyticsObjectCollectionRulesResponse
     * @throws OciError when an error occurs
     */
    listLogAnalyticsObjectCollectionRules(listLogAnalyticsObjectCollectionRulesRequest: requests.ListLogAnalyticsObjectCollectionRulesRequest): Promise<responses.ListLogAnalyticsObjectCollectionRulesResponse>;
    /**
     * get all meta source types
     * @param ListMetaSourceTypesRequest
     * @return ListMetaSourceTypesResponse
     * @throws OciError when an error occurs
     */
    listMetaSourceTypes(listMetaSourceTypesRequest: requests.ListMetaSourceTypesRequest): Promise<responses.ListMetaSourceTypesResponse>;
    /**
     * Given a tenancy OCID, this API returns the namespace of the tenancy if it is valid and subscribed to the region.  The
     * result also indicates if the tenancy is onboarded with Logging Analytics.
     *
     * @param ListNamespacesRequest
     * @return ListNamespacesResponse
     * @throws OciError when an error occurs
     */
    listNamespaces(listNamespacesRequest: requests.ListNamespacesRequest): Promise<responses.ListNamespacesResponse>;
    /**
     * get pre-process plugin instance
     * @param ListParserFunctionsRequest
     * @return ListParserFunctionsResponse
     * @throws OciError when an error occurs
     */
    listParserFunctions(listParserFunctionsRequest: requests.ListParserFunctionsRequest): Promise<responses.ListParserFunctionsResponse>;
    /**
     * get pre-process Meta plugins
     * @param ListParserMetaPluginsRequest
     * @return ListParserMetaPluginsResponse
     * @throws OciError when an error occurs
     */
    listParserMetaPlugins(listParserMetaPluginsRequest: requests.ListParserMetaPluginsRequest): Promise<responses.ListParserMetaPluginsResponse>;
    /**
     * List parsers passing specified filter
     * @param ListParsersRequest
     * @return ListParsersResponse
     * @throws OciError when an error occurs
     */
    listParsers(listParsersRequest: requests.ListParsersRequest): Promise<responses.ListParsersResponse>;
    /**
     * List active asynchronous queries.
     * @param ListQueryWorkRequestsRequest
     * @return ListQueryWorkRequestsResponse
     * @throws OciError when an error occurs
     */
    listQueryWorkRequests(listQueryWorkRequestsRequest: requests.ListQueryWorkRequestsRequest): Promise<responses.ListQueryWorkRequestsResponse>;
    /**
     * Lists scheduled tasks.
     * @param ListScheduledTasksRequest
     * @return ListScheduledTasksResponse
     * @throws OciError when an error occurs
     */
    listScheduledTasks(listScheduledTasksRequest: requests.ListScheduledTasksRequest): Promise<responses.ListScheduledTasksResponse>;
    /**
     * association summary by source
     * @param ListSourceAssociationsRequest
     * @return ListSourceAssociationsResponse
     * @throws OciError when an error occurs
     */
    listSourceAssociations(listSourceAssociationsRequest: requests.ListSourceAssociationsRequest): Promise<responses.ListSourceAssociationsResponse>;
    /**
     * get source extended fields for source with specified Id
     * @param ListSourceExtendedFieldDefinitionsRequest
     * @return ListSourceExtendedFieldDefinitionsResponse
     * @throws OciError when an error occurs
     */
    listSourceExtendedFieldDefinitions(listSourceExtendedFieldDefinitionsRequest: requests.ListSourceExtendedFieldDefinitionsRequest): Promise<responses.ListSourceExtendedFieldDefinitionsResponse>;
    /**
     * list source label operators
     * @param ListSourceLabelOperatorsRequest
     * @return ListSourceLabelOperatorsResponse
     * @throws OciError when an error occurs
     */
    listSourceLabelOperators(listSourceLabelOperatorsRequest: requests.ListSourceLabelOperatorsRequest): Promise<responses.ListSourceLabelOperatorsResponse>;
    /**
     * get source meta functions
     * @param ListSourceMetaFunctionsRequest
     * @return ListSourceMetaFunctionsResponse
     * @throws OciError when an error occurs
     */
    listSourceMetaFunctions(listSourceMetaFunctionsRequest: requests.ListSourceMetaFunctionsRequest): Promise<responses.ListSourceMetaFunctionsResponse>;
    /**
     * get source patterns for source with specified Id
     * @param ListSourcePatternsRequest
     * @return ListSourcePatternsResponse
     * @throws OciError when an error occurs
     */
    listSourcePatterns(listSourcePatternsRequest: requests.ListSourcePatternsRequest): Promise<responses.ListSourcePatternsResponse>;
    /**
     * source list
     * @param ListSourcesRequest
     * @return ListSourcesResponse
     * @throws OciError when an error occurs
     */
    listSources(listSourcesRequest: requests.ListSourcesRequest): Promise<responses.ListSourcesResponse>;
    /**
     * This API returns the list of work request errors if any.
     * @param ListStorageWorkRequestErrorsRequest
     * @return ListStorageWorkRequestErrorsResponse
     * @throws OciError when an error occurs
     */
    listStorageWorkRequestErrors(listStorageWorkRequestErrorsRequest: requests.ListStorageWorkRequestErrorsRequest): Promise<responses.ListStorageWorkRequestErrorsResponse>;
    /**
     * This API lists storage work requests.  Use query parameters to narrow down or sort the result list.
     *
     * @param ListStorageWorkRequestsRequest
     * @return ListStorageWorkRequestsResponse
     * @throws OciError when an error occurs
     */
    listStorageWorkRequests(listStorageWorkRequestsRequest: requests.ListStorageWorkRequestsRequest): Promise<responses.ListStorageWorkRequestsResponse>;
    /**
     * Gets the list of character encodings supported for log files.
     * @param ListSupportedCharEncodingsRequest
     * @return ListSupportedCharEncodingsResponse
     * @throws OciError when an error occurs
     */
    listSupportedCharEncodings(listSupportedCharEncodingsRequest: requests.ListSupportedCharEncodingsRequest): Promise<responses.ListSupportedCharEncodingsResponse>;
    /**
     * Gets timezones that are supported when performing uploads.
     * @param ListSupportedTimezonesRequest
     * @return ListSupportedTimezonesResponse
     * @throws OciError when an error occurs
     */
    listSupportedTimezones(listSupportedTimezonesRequest: requests.ListSupportedTimezonesRequest): Promise<responses.ListSupportedTimezonesResponse>;
    /**
     * Gets list of files in an upload.
     * @param ListUploadFilesRequest
     * @return ListUploadFilesResponse
     * @throws OciError when an error occurs
     */
    listUploadFiles(listUploadFilesRequest: requests.ListUploadFilesRequest): Promise<responses.ListUploadFilesResponse>;
    /**
     * Gets list of warnings in an upload explaining the failures due to incorrect configuration.
     * @param ListUploadWarningsRequest
     * @return ListUploadWarningsResponse
     * @throws OciError when an error occurs
     */
    listUploadWarnings(listUploadWarningsRequest: requests.ListUploadWarningsRequest): Promise<responses.ListUploadWarningsResponse>;
    /**
     * Gets a list of all On-demand uploads.
     * To use this and other API operations, you must be authorized in an IAM policy.
     *
     * @param ListUploadsRequest
     * @return ListUploadsResponse
     * @throws OciError when an error occurs
     */
    listUploads(listUploadsRequest: requests.ListUploadsRequest): Promise<responses.ListUploadsResponse>;
    /**
     * Return a (paginated) list of errors for a given work request.
     *
     * @param ListWorkRequestErrorsRequest
     * @return ListWorkRequestErrorsResponse
     * @throws OciError when an error occurs
     */
    listWorkRequestErrors(listWorkRequestErrorsRequest: requests.ListWorkRequestErrorsRequest): Promise<responses.ListWorkRequestErrorsResponse>;
    /**
     * Return a (paginated) list of logs for a given work request.
     *
     * @param ListWorkRequestLogsRequest
     * @return ListWorkRequestLogsResponse
     * @throws OciError when an error occurs
     */
    listWorkRequestLogs(listWorkRequestLogsRequest: requests.ListWorkRequestLogsRequest): Promise<responses.ListWorkRequestLogsResponse>;
    /**
     * Lists the work requests in a compartment.
     *
     * @param ListWorkRequestsRequest
     * @return ListWorkRequestsResponse
     * @throws OciError when an error occurs
     */
    listWorkRequests(listWorkRequestsRequest: requests.ListWorkRequestsRequest): Promise<responses.ListWorkRequestsResponse>;
    /**
     * Off-boards a tenant from Logging Analytics
     * @param OffboardNamespaceRequest
     * @return OffboardNamespaceResponse
     * @throws OciError when an error occurs
     */
    offboardNamespace(offboardNamespaceRequest: requests.OffboardNamespaceRequest): Promise<responses.OffboardNamespaceResponse>;
    /**
     * On-boards a tenant to Logging Analytics.
     *
     * @param OnboardNamespaceRequest
     * @return OnboardNamespaceResponse
     * @throws OciError when an error occurs
     */
    onboardNamespace(onboardNamespaceRequest: requests.OnboardNamespaceRequest): Promise<responses.OnboardNamespaceResponse>;
    /**
     * Describe query
     * @param ParseQueryRequest
     * @return ParseQueryResponse
     * @throws OciError when an error occurs
     */
    parseQuery(parseQueryRequest: requests.ParseQueryRequest): Promise<responses.ParseQueryResponse>;
    /**
     * This API submits a work request to purge data. Only data from log groups that the user has permission to delete
     * will be purged.  To purge all data, the user must have permission to all log groups.
     *
     * @param PurgeStorageDataRequest
     * @return PurgeStorageDataResponse
     * @throws OciError when an error occurs
     */
    purgeStorageData(purgeStorageDataRequest: requests.PurgeStorageDataRequest): Promise<responses.PurgeStorageDataResponse>;
    /**
     * Put the work request specified by {workRequestId} into the background. Backgrounded queries will preserve query results on query completion for up to 7 days for recall. After 7 days the results and query expire.
     * @param PutQueryWorkRequestBackgroundRequest
     * @return PutQueryWorkRequestBackgroundResponse
     * @throws OciError when an error occurs
     */
    putQueryWorkRequestBackground(putQueryWorkRequestBackgroundRequest: requests.PutQueryWorkRequestBackgroundRequest): Promise<responses.PutQueryWorkRequestBackgroundResponse>;
    /**
     * Performs a log analytics search, if shouldRunAsync is false returns the query results once they become available subject to 60 second timeout. If a query is subject to exceed that time then it should be run asynchronously. Asynchronous query submissions return the queryWorkRequestId to use for execution tracking, query submission lifecycle actions and to poll for query results.
     *
     * @param QueryRequest
     * @return QueryResponse
     * @throws OciError when an error occurs
     */
    query(queryRequest: requests.QueryRequest): Promise<responses.QueryResponse>;
    /**
     * This API submits a work request to recall archived data based on time interval and data type.
     *
     * @param RecallArchivedDataRequest
     * @return RecallArchivedDataResponse
     * @throws OciError when an error occurs
     */
    recallArchivedData(recallArchivedDataRequest: requests.RecallArchivedDataRequest): Promise<responses.RecallArchivedDataResponse>;
    /**
     * register lookup
     * @param RegisterLookupRequest
     * @return RegisterLookupResponse
     * @throws OciError when an error occurs
     */
    registerLookup(registerLookupRequest: requests.RegisterLookupRequest): Promise<responses.RegisterLookupResponse>;
    /**
     * This API submits a work request to release recalled data based on time interval and data type.
     *
     * @param ReleaseRecalledDataRequest
     * @return ReleaseRecalledDataResponse
     * @throws OciError when an error occurs
     */
    releaseRecalledData(releaseRecalledDataRequest: requests.ReleaseRecalledDataRequest): Promise<responses.ReleaseRecalledDataResponse>;
    /**
     * Delete association between input source log analytics entity and destination entities.
     * @param RemoveEntityAssociationsRequest
     * @return RemoveEntityAssociationsResponse
     * @throws OciError when an error occurs
     */
    removeEntityAssociations(removeEntityAssociationsRequest: requests.RemoveEntityAssociationsRequest): Promise<responses.RemoveEntityAssociationsResponse>;
    /**
     * Execute the saved search acceleration task in the foreground.
     * The ScheduledTask taskType must be ACCELERATION.
     * Optionally specify time range (timeStart and timeEnd). The default is all time.
     *
     * @param RunRequest
     * @return RunResponse
     * @throws OciError when an error occurs
     */
    run(runRequest: requests.RunRequest): Promise<responses.RunResponse>;
    /**
     * Returns a context specific list of either commands, fields, or values to append to the end of the specified query string if applicable.
     * @param SuggestRequest
     * @return SuggestResponse
     * @throws OciError when an error occurs
     */
    suggest(suggestRequest: requests.SuggestRequest): Promise<responses.SuggestResponse>;
    /**
     * test parser
     * @param TestParserRequest
     * @return TestParserResponse
     * @throws OciError when an error occurs
     */
    testParser(testParserRequest: requests.TestParserRequest): Promise<responses.TestParserResponse>;
    /**
     * Update the log analytics entity with the given id.
     * @param UpdateLogAnalyticsEntityRequest
     * @return UpdateLogAnalyticsEntityResponse
     * @throws OciError when an error occurs
     */
    updateLogAnalyticsEntity(updateLogAnalyticsEntityRequest: requests.UpdateLogAnalyticsEntityRequest): Promise<responses.UpdateLogAnalyticsEntityResponse>;
    /**
     * Update custom log analytics entity type. Out of box entity types cannot be udpated.
     * @param UpdateLogAnalyticsEntityTypeRequest
     * @return UpdateLogAnalyticsEntityTypeResponse
     * @throws OciError when an error occurs
     */
    updateLogAnalyticsEntityType(updateLogAnalyticsEntityTypeRequest: requests.UpdateLogAnalyticsEntityTypeRequest): Promise<responses.UpdateLogAnalyticsEntityTypeResponse>;
    /**
     * Updates the Log-Analytics group with the given id.
     * @param UpdateLogAnalyticsLogGroupRequest
     * @return UpdateLogAnalyticsLogGroupResponse
     * @throws OciError when an error occurs
     */
    updateLogAnalyticsLogGroup(updateLogAnalyticsLogGroupRequest: requests.UpdateLogAnalyticsLogGroupRequest): Promise<responses.UpdateLogAnalyticsLogGroupResponse>;
    /**
     * Update the rule with the given id.
     * @param UpdateLogAnalyticsObjectCollectionRuleRequest
     * @return UpdateLogAnalyticsObjectCollectionRuleResponse
     * @throws OciError when an error occurs
     */
    updateLogAnalyticsObjectCollectionRule(updateLogAnalyticsObjectCollectionRuleRequest: requests.UpdateLogAnalyticsObjectCollectionRuleRequest): Promise<responses.UpdateLogAnalyticsObjectCollectionRuleResponse>;
    /**
     * Update the scheduled task. Schedules may be updated only for taskType SAVED_SEARCH and PURGE.
     * @param UpdateScheduledTaskRequest
     * @return UpdateScheduledTaskResponse
     * @throws OciError when an error occurs
     */
    updateScheduledTask(updateScheduledTaskRequest: requests.UpdateScheduledTaskRequest): Promise<responses.UpdateScheduledTaskResponse>;
    /**
     * This API updates the archiving configuration
     *
     * @param UpdateStorageRequest
     * @return UpdateStorageResponse
     * @throws OciError when an error occurs
     */
    updateStorage(updateStorageRequest: requests.UpdateStorageRequest): Promise<responses.UpdateStorageResponse>;
    /**
     * Accepts log data for processing by Logging Analytics.
     *
     * @param UploadLogFileRequest
     * @return UploadLogFileResponse
     * @throws OciError when an error occurs
     */
    uploadLogFile(uploadLogFileRequest: requests.UploadLogFileRequest): Promise<responses.UploadLogFileResponse>;
    /**
     * create or update associations for a source
     * @param UpsertAssociationsRequest
     * @return UpsertAssociationsResponse
     * @throws OciError when an error occurs
     */
    upsertAssociations(upsertAssociationsRequest: requests.UpsertAssociationsRequest): Promise<responses.UpsertAssociationsResponse>;
    /**
     * Defines or update a field.
     * @param UpsertFieldRequest
     * @return UpsertFieldResponse
     * @throws OciError when an error occurs
     */
    upsertField(upsertFieldRequest: requests.UpsertFieldRequest): Promise<responses.UpsertFieldResponse>;
    /**
     * Define or update a label.
     * @param UpsertLabelRequest
     * @return UpsertLabelResponse
     * @throws OciError when an error occurs
     */
    upsertLabel(upsertLabelRequest: requests.UpsertLabelRequest): Promise<responses.UpsertLabelResponse>;
    /**
     * Define or update parser
     * @param UpsertParserRequest
     * @return UpsertParserResponse
     * @throws OciError when an error occurs
     */
    upsertParser(upsertParserRequest: requests.UpsertParserRequest): Promise<responses.UpsertParserResponse>;
    /**
     * Define or update a source
     * @param UpsertSourceRequest
     * @return UpsertSourceResponse
     * @throws OciError when an error occurs
     */
    upsertSource(upsertSourceRequest: requests.UpsertSourceRequest): Promise<responses.UpsertSourceResponse>;
    /**
     * association parameter validation
     * @param ValidateAssociationParametersRequest
     * @return ValidateAssociationParametersResponse
     * @throws OciError when an error occurs
     */
    validateAssociationParameters(validateAssociationParametersRequest: requests.ValidateAssociationParametersRequest): Promise<responses.ValidateAssociationParametersResponse>;
    /**
     * Validates a log file to check whether it is eligible to upload or not.
     * @param ValidateFileRequest
     * @return ValidateFileResponse
     * @throws OciError when an error occurs
     */
    validateFile(validateFileRequest: requests.ValidateFileRequest): Promise<responses.ValidateFileResponse>;
    /**
     * Pre-define or update a source
     * @param ValidateSourceRequest
     * @return ValidateSourceResponse
     * @throws OciError when an error occurs
     */
    validateSource(validateSourceRequest: requests.ValidateSourceRequest): Promise<responses.ValidateSourceResponse>;
    /**
     * test extended fields
     * @param ValidateSourceExtendedFieldDetailsRequest
     * @return ValidateSourceExtendedFieldDetailsResponse
     * @throws OciError when an error occurs
     */
    validateSourceExtendedFieldDetails(validateSourceExtendedFieldDetailsRequest: requests.ValidateSourceExtendedFieldDetailsRequest): Promise<responses.ValidateSourceExtendedFieldDetailsResponse>;
    /**
     * Validates the source mapping for given file and provides match status and parsed representation of log data.
     * @param ValidateSourceMappingRequest
     * @return ValidateSourceMappingResponse
     * @throws OciError when an error occurs
     */
    validateSourceMapping(validateSourceMappingRequest: requests.ValidateSourceMappingRequest): Promise<responses.ValidateSourceMappingResponse>;
}
