"use strict";
/**
 * Logging Management API
 * Use the Logging Management API to create, read, list, update, and delete log groups, log objects, and agent configurations.
 * OpenAPI spec version: 20200531
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const model = __importStar(require("../model"));
var UnifiedAgentParser;
(function (UnifiedAgentParser) {
    function getJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {});
        if ("parserType" in obj && obj.parserType) {
            switch (obj.parserType) {
                case "MULTILINE_GROK":
                    return model.UnifiedAgentMultilineGrokParser.getJsonObj(jsonObj, true);
                case "JSON":
                    return model.UnifiedJSONParser.getJsonObj(jsonObj, true);
                case "GROK":
                    return model.UnifiedAgentGrokParser.getJsonObj(jsonObj, true);
                case "NONE":
                    return model.UnifiedAgentNoneParser.getJsonObj(jsonObj, true);
                case "SYSLOG":
                    return model.UnifiedAgentSyslogParser.getJsonObj(jsonObj, true);
                case "AUDITD":
                    return model.UnifiedAgentAuditdParser.getJsonObj(jsonObj, true);
                case "APACHE2":
                    return model.UnifiedAgentApache2Parser.getJsonObj(jsonObj, true);
                case "REGEXP":
                    return model.UnifiedAgentRegexParser.getJsonObj(jsonObj, true);
                case "MULTILINE":
                    return model.UnifiedAgentMultilineParser.getJsonObj(jsonObj, true);
                case "TSV":
                    return model.UnifiedAgentTsvParser.getJsonObj(jsonObj, true);
                case "APACHE_ERROR":
                    return model.UnifiedAgentApacheErrorParser.getJsonObj(jsonObj, true);
                case "MSGPACK":
                    return model.UnifiedAgentMsgpackParser.getJsonObj(jsonObj, true);
                case "CSV":
                    return model.UnifiedAgentCsvParser.getJsonObj(jsonObj, true);
                default:
                    throw Error("Unknown value for: " + obj.parserType);
            }
        }
        return jsonObj;
    }
    UnifiedAgentParser.getJsonObj = getJsonObj;
})(UnifiedAgentParser = exports.UnifiedAgentParser || (exports.UnifiedAgentParser = {}));
//# sourceMappingURL=unified-agent-parser.js.map