"use strict";
/**
 * Monitoring API
 * Use the Monitoring API to manage metric queries and alarms for assessing the health, capacity, and performance of your cloud resources.
Endpoints vary by operation. For PostMetric, use the `telemetry-ingestion` endpoints; for all other operations, use the `telemetry` endpoints.
For information about monitoring, see [Monitoring Overview](/iaas/Content/Monitoring/Concepts/monitoringoverview.htm).

 * OpenAPI spec version: 20180401
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const model = __importStar(require("../model"));
var AlarmStatusSummary;
(function (AlarmStatusSummary) {
    let Severity;
    (function (Severity) {
        Severity["Critical"] = "CRITICAL";
        Severity["Error"] = "ERROR";
        Severity["Warning"] = "WARNING";
        Severity["Info"] = "INFO";
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        Severity["UnknownValue"] = "UNKNOWN_VALUE";
    })(Severity = AlarmStatusSummary.Severity || (AlarmStatusSummary.Severity = {}));
    let Status;
    (function (Status) {
        Status["Firing"] = "FIRING";
        Status["Ok"] = "OK";
        Status["Suspended"] = "SUSPENDED";
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        Status["UnknownValue"] = "UNKNOWN_VALUE";
    })(Status = AlarmStatusSummary.Status || (AlarmStatusSummary.Status = {}));
    function getJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {
            "suppression": obj.suppression ? model.Suppression.getJsonObj(obj.suppression) : undefined
        });
        return jsonObj;
    }
    AlarmStatusSummary.getJsonObj = getJsonObj;
})(AlarmStatusSummary = exports.AlarmStatusSummary || (exports.AlarmStatusSummary = {}));
//# sourceMappingURL=alarm-status-summary.js.map