"use strict";
/**
 * Operations Insights API
 * Use the Operations Insights API to perform data extraction operations to obtain database
resource utilization, performance statistics, and reference information. For more information,
see [About Oracle Cloud Infrastructure Operations Insights](https://docs.cloud.oracle.com/en-us/iaas/operations-insights/doc/operations-insights.html).

 * OpenAPI spec version: 20200630
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const DatabaseDetails = __importStar(require("./database-details"));
exports.DatabaseDetails = DatabaseDetails.DatabaseDetails;
const DatabaseInsightSummary = __importStar(require("./database-insight-summary"));
exports.DatabaseInsightSummary = DatabaseInsightSummary.DatabaseInsightSummary;
const DatabaseInsights = __importStar(require("./database-insights"));
exports.DatabaseInsights = DatabaseInsights.DatabaseInsights;
const DatabaseInsightsCollection = __importStar(require("./database-insights-collection"));
exports.DatabaseInsightsCollection = DatabaseInsightsCollection.DatabaseInsightsCollection;
const HistoricalDataItem = __importStar(require("./historical-data-item"));
exports.HistoricalDataItem = HistoricalDataItem.HistoricalDataItem;
const IngestSqlBucketDetails = __importStar(require("./ingest-sql-bucket-details"));
exports.IngestSqlBucketDetails = IngestSqlBucketDetails.IngestSqlBucketDetails;
const IngestSqlBucketResponseDetails = __importStar(require("./ingest-sql-bucket-response-details"));
exports.IngestSqlBucketResponseDetails = IngestSqlBucketResponseDetails.IngestSqlBucketResponseDetails;
const IngestSqlPlanLinesDetails = __importStar(require("./ingest-sql-plan-lines-details"));
exports.IngestSqlPlanLinesDetails = IngestSqlPlanLinesDetails.IngestSqlPlanLinesDetails;
const IngestSqlPlanLinesResponseDetails = __importStar(require("./ingest-sql-plan-lines-response-details"));
exports.IngestSqlPlanLinesResponseDetails = IngestSqlPlanLinesResponseDetails.IngestSqlPlanLinesResponseDetails;
const IngestSqlTextDetails = __importStar(require("./ingest-sql-text-details"));
exports.IngestSqlTextDetails = IngestSqlTextDetails.IngestSqlTextDetails;
const IngestSqlTextResponseDetails = __importStar(require("./ingest-sql-text-response-details"));
exports.IngestSqlTextResponseDetails = IngestSqlTextResponseDetails.IngestSqlTextResponseDetails;
const ProjectedDataItem = __importStar(require("./projected-data-item"));
exports.ProjectedDataItem = ProjectedDataItem.ProjectedDataItem;
const ResourceCapacityTrendAggregation = __importStar(require("./resource-capacity-trend-aggregation"));
exports.ResourceCapacityTrendAggregation = ResourceCapacityTrendAggregation.ResourceCapacityTrendAggregation;
const ResourceInsightCurrentUtilization = __importStar(require("./resource-insight-current-utilization"));
exports.ResourceInsightCurrentUtilization = ResourceInsightCurrentUtilization.ResourceInsightCurrentUtilization;
const ResourceInsightProjectedUtilization = __importStar(require("./resource-insight-projected-utilization"));
exports.ResourceInsightProjectedUtilization = ResourceInsightProjectedUtilization.ResourceInsightProjectedUtilization;
const ResourceInsightProjectedUtilizationItem = __importStar(require("./resource-insight-projected-utilization-item"));
exports.ResourceInsightProjectedUtilizationItem = ResourceInsightProjectedUtilizationItem.ResourceInsightProjectedUtilizationItem;
const ResourceStatistics = __importStar(require("./resource-statistics"));
exports.ResourceStatistics = ResourceStatistics.ResourceStatistics;
const ResourceStatisticsAggregation = __importStar(require("./resource-statistics-aggregation"));
exports.ResourceStatisticsAggregation = ResourceStatisticsAggregation.ResourceStatisticsAggregation;
const ResourceUsageTrendAggregation = __importStar(require("./resource-usage-trend-aggregation"));
exports.ResourceUsageTrendAggregation = ResourceUsageTrendAggregation.ResourceUsageTrendAggregation;
const SortOrder = __importStar(require("./sort-order"));
exports.SortOrder = SortOrder.SortOrder;
const SqlBucket = __importStar(require("./sql-bucket"));
exports.SqlBucket = SqlBucket.SqlBucket;
const SqlInsightAggregation = __importStar(require("./sql-insight-aggregation"));
exports.SqlInsightAggregation = SqlInsightAggregation.SqlInsightAggregation;
const SqlInsightAggregationCollection = __importStar(require("./sql-insight-aggregation-collection"));
exports.SqlInsightAggregationCollection = SqlInsightAggregationCollection.SqlInsightAggregationCollection;
const SqlInsightThresholds = __importStar(require("./sql-insight-thresholds"));
exports.SqlInsightThresholds = SqlInsightThresholds.SqlInsightThresholds;
const SqlInventory = __importStar(require("./sql-inventory"));
exports.SqlInventory = SqlInventory.SqlInventory;
const SqlPlanCollection = __importStar(require("./sql-plan-collection"));
exports.SqlPlanCollection = SqlPlanCollection.SqlPlanCollection;
const SqlPlanInsightAggregation = __importStar(require("./sql-plan-insight-aggregation"));
exports.SqlPlanInsightAggregation = SqlPlanInsightAggregation.SqlPlanInsightAggregation;
const SqlPlanInsightAggregationCollection = __importStar(require("./sql-plan-insight-aggregation-collection"));
exports.SqlPlanInsightAggregationCollection = SqlPlanInsightAggregationCollection.SqlPlanInsightAggregationCollection;
const SqlPlanInsights = __importStar(require("./sql-plan-insights"));
exports.SqlPlanInsights = SqlPlanInsights.SqlPlanInsights;
const SqlPlanLine = __importStar(require("./sql-plan-line"));
exports.SqlPlanLine = SqlPlanLine.SqlPlanLine;
const SqlPlanSummary = __importStar(require("./sql-plan-summary"));
exports.SqlPlanSummary = SqlPlanSummary.SqlPlanSummary;
const SqlResponseTimeDistributionAggregation = __importStar(require("./sql-response-time-distribution-aggregation"));
exports.SqlResponseTimeDistributionAggregation = SqlResponseTimeDistributionAggregation.SqlResponseTimeDistributionAggregation;
const SqlResponseTimeDistributionAggregationCollection = __importStar(require("./sql-response-time-distribution-aggregation-collection"));
exports.SqlResponseTimeDistributionAggregationCollection = SqlResponseTimeDistributionAggregationCollection.SqlResponseTimeDistributionAggregationCollection;
const SqlSearchCollection = __importStar(require("./sql-search-collection"));
exports.SqlSearchCollection = SqlSearchCollection.SqlSearchCollection;
const SqlSearchSummary = __importStar(require("./sql-search-summary"));
exports.SqlSearchSummary = SqlSearchSummary.SqlSearchSummary;
const SqlStatisticAggregation = __importStar(require("./sql-statistic-aggregation"));
exports.SqlStatisticAggregation = SqlStatisticAggregation.SqlStatisticAggregation;
const SqlStatisticAggregationCollection = __importStar(require("./sql-statistic-aggregation-collection"));
exports.SqlStatisticAggregationCollection = SqlStatisticAggregationCollection.SqlStatisticAggregationCollection;
const SqlStatistics = __importStar(require("./sql-statistics"));
exports.SqlStatistics = SqlStatistics.SqlStatistics;
const SqlStatisticsTimeSeries = __importStar(require("./sql-statistics-time-series"));
exports.SqlStatisticsTimeSeries = SqlStatisticsTimeSeries.SqlStatisticsTimeSeries;
const SqlStatisticsTimeSeriesAggregation = __importStar(require("./sql-statistics-time-series-aggregation"));
exports.SqlStatisticsTimeSeriesAggregation = SqlStatisticsTimeSeriesAggregation.SqlStatisticsTimeSeriesAggregation;
const SqlStatisticsTimeSeriesAggregationCollection = __importStar(require("./sql-statistics-time-series-aggregation-collection"));
exports.SqlStatisticsTimeSeriesAggregationCollection = SqlStatisticsTimeSeriesAggregationCollection.SqlStatisticsTimeSeriesAggregationCollection;
const SqlStatisticsTimeSeriesByPlanAggregation = __importStar(require("./sql-statistics-time-series-by-plan-aggregation"));
exports.SqlStatisticsTimeSeriesByPlanAggregation = SqlStatisticsTimeSeriesByPlanAggregation.SqlStatisticsTimeSeriesByPlanAggregation;
const SqlStatisticsTimeSeriesByPlanAggregationCollection = __importStar(require("./sql-statistics-time-series-by-plan-aggregation-collection"));
exports.SqlStatisticsTimeSeriesByPlanAggregationCollection = SqlStatisticsTimeSeriesByPlanAggregationCollection.SqlStatisticsTimeSeriesByPlanAggregationCollection;
const SqlText = __importStar(require("./sql-text"));
exports.SqlText = SqlText.SqlText;
const SqlTextCollection = __importStar(require("./sql-text-collection"));
exports.SqlTextCollection = SqlTextCollection.SqlTextCollection;
const SqlTextSummary = __importStar(require("./sql-text-summary"));
exports.SqlTextSummary = SqlTextSummary.SqlTextSummary;
const SummarizeDatabaseInsightResourceCapacityTrendAggregationCollection = __importStar(require("./summarize-database-insight-resource-capacity-trend-aggregation-collection"));
exports.SummarizeDatabaseInsightResourceCapacityTrendAggregationCollection = SummarizeDatabaseInsightResourceCapacityTrendAggregationCollection.SummarizeDatabaseInsightResourceCapacityTrendAggregationCollection;
const SummarizeDatabaseInsightResourceForecastTrendAggregation = __importStar(require("./summarize-database-insight-resource-forecast-trend-aggregation"));
exports.SummarizeDatabaseInsightResourceForecastTrendAggregation = SummarizeDatabaseInsightResourceForecastTrendAggregation.SummarizeDatabaseInsightResourceForecastTrendAggregation;
const SummarizeDatabaseInsightResourceStatisticsAggregationCollection = __importStar(require("./summarize-database-insight-resource-statistics-aggregation-collection"));
exports.SummarizeDatabaseInsightResourceStatisticsAggregationCollection = SummarizeDatabaseInsightResourceStatisticsAggregationCollection.SummarizeDatabaseInsightResourceStatisticsAggregationCollection;
const SummarizeDatabaseInsightResourceUsageAggregation = __importStar(require("./summarize-database-insight-resource-usage-aggregation"));
exports.SummarizeDatabaseInsightResourceUsageAggregation = SummarizeDatabaseInsightResourceUsageAggregation.SummarizeDatabaseInsightResourceUsageAggregation;
const SummarizeDatabaseInsightResourceUsageTrendAggregationCollection = __importStar(require("./summarize-database-insight-resource-usage-trend-aggregation-collection"));
exports.SummarizeDatabaseInsightResourceUsageTrendAggregationCollection = SummarizeDatabaseInsightResourceUsageTrendAggregationCollection.SummarizeDatabaseInsightResourceUsageTrendAggregationCollection;
const SummarizeDatabaseInsightResourceUtilizationInsightAggregation = __importStar(require("./summarize-database-insight-resource-utilization-insight-aggregation"));
exports.SummarizeDatabaseInsightResourceUtilizationInsightAggregation = SummarizeDatabaseInsightResourceUtilizationInsightAggregation.SummarizeDatabaseInsightResourceUtilizationInsightAggregation;
const UsageUnit = __importStar(require("./usage-unit"));
exports.UsageUnit = UsageUnit.UsageUnit;
//# sourceMappingURL=index.js.map