"use strict";
/**
 * Resource Manager API
 * API for the Resource Manager service.
Use this API to install, configure, and manage resources via the "infrastructure-as-code" model.
For more information, see
[Overview of Resource Manager](/iaas/Content/ResourceManager/Concepts/resourcemanager.htm).

 * OpenAPI spec version: 20180917
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const model = __importStar(require("../model"));
var ConfigSource;
(function (ConfigSource) {
    function getJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {});
        if ("configSourceType" in obj && obj.configSourceType) {
            switch (obj.configSourceType) {
                case "GIT_CONFIG_SOURCE":
                    return model.GitConfigSource.getJsonObj(jsonObj, true);
                case "COMPARTMENT_CONFIG_SOURCE":
                    return model.CompartmentConfigSource.getJsonObj(jsonObj, true);
                case "ZIP_UPLOAD":
                    return model.ZipUploadConfigSource.getJsonObj(jsonObj, true);
                default:
                    throw Error("Unknown value for: " + obj.configSourceType);
            }
        }
        return jsonObj;
    }
    ConfigSource.getJsonObj = getJsonObj;
})(ConfigSource = exports.ConfigSource || (exports.ConfigSource = {}));
//# sourceMappingURL=config-source.js.map